#ifndef lint
static const char yysccsid[] = "@(#)yaccpar	1.9 (Berkeley) 02/21/93";
#endif

#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define YYPATCH 20100610

#define YYEMPTY        (-1)
#define yyclearin      (yychar = YYEMPTY)
#define yyerrok        (yyerrflag = 0)
#define YYRECOVERING() (yyerrflag != 0)

#define YYPREFIX "yy"

#define YYPURE 0

#line 2 "gram.y"
/* $Header$ */

/*
 * Copyright © 1988-2004 Keith Packard and Bart Massey.
 * All Rights Reserved.  See the file COPYING in this directory
 * for licensing information.
 */

#include	"nickle.h"
#include	<stdio.h>

/*
 * This grammar generates 1 shift/reduce conflict and 4 reduce/reduce:
 * 
 * 2 reduce/reduce conflicts on:
 *
 *	    *int . func 
 *	    **int . func
 *
 *	Is the '*' a dereference operator or a pointer type modifier?
 *	The grammar is ordered to make this a type modifier since
 *	the other way is less common.  Use parens when you want this.
 *
 * 2 reduce/reduce conflicts on:
 *
 *	   &int . func
 *	   &&int . func
 *
 *	Is the '&' a reference operator or a reference type modifier?
 *	The grammar is ordered to make this a type modifier since
 *	the other way is less common.  Use parens when you want this.
 *
 *  shift/reduce conflict in ASSIGN in initializers
 *
 *	That's because struct initializers look like assignment
 *	expressions while array initializers permit any expression.
 *	Shift yields struct initialization, so the effect is
 *	to make assignment expressions invalid in array initializers.
 *	(Of course, you can always enclose an assignment in parens.)
 *      (I can't see any obvious way to use operator precedence to
 *      get rid of this: seems like you'd need to duplicate simpleexpr
 *      with different precedence. --BCM)
 *
 */
int ignorenl;
int notCommand;
int seeComment;
NamespacePtr	LexNamespace;
int funcDepth;

void ParseError (char *fmt, ...);
void yyerror (char *msg);

typedef enum _CanonTypeResult {
    CanonTypeUndefined,
    CanonTypeForward,
    CanonTypeDefined,
} CanonTypeResult;
    
static Expr *
ParseCanonFor (Expr *expr);

static CanonTypeResult
ParseCanonType (TypePtr type, Bool forwardAllowed);

static SymbolPtr
ParseNewSymbol (Publish publish, Class class, Type *type, Atom name);

#line 72 "gram.y"
typedef union {
    int		    ints;
    Value	    value;
    Class	    class;
    ArgType	    *argType;
    Type	    *type;
    Publish	    publish;
    ExprPtr	    expr;
    Atom	    atom;
    DeclListPtr	    declList;
    MemListPtr	    memList;
    Fulltype	    fulltype;
    ArgDecl	    argDecl;
    SymbolPtr	    symbol;
    NamespacePtr    namespace;
    CodePtr	    code;
    Bool	    bool;
    AtomListPtr	    atomList;
    FuncDecl	    funcDecl;
} YYSTYPE;
#line 109 "gram.c"
/* compatibility with bison */
#ifdef YYPARSE_PARAM
/* compatibility with FreeBSD */
# ifdef YYPARSE_PARAM_TYPE
#  define YYPARSE_DECL() yyparse(YYPARSE_PARAM_TYPE YYPARSE_PARAM)
# else
#  define YYPARSE_DECL() yyparse(void *YYPARSE_PARAM)
# endif
#else
# define YYPARSE_DECL() yyparse(void)
#endif

/* Parameters sent to lex. */
#ifdef YYLEX_PARAM
# define YYLEX_DECL() yylex(void *YYLEX_PARAM)
# define YYLEX yylex(YYLEX_PARAM)
#else
# define YYLEX_DECL() yylex(void)
# define YYLEX yylex()
#endif

extern int YYPARSE_DECL();
extern int YYLEX_DECL();

#define VAR 257
#define EXPR 258
#define ARRAY 259
#define STRUCT 260
#define UNION 261
#define ENUM 262
#define COMP 263
#define HASH 264
#define SEMI 265
#define MOD 266
#define OC 267
#define CC 268
#define DOLLAR 269
#define DOTDOTDOT 270
#define ENDFILE 271
#define GLOBAL 272
#define AUTO 273
#define STATIC 274
#define CONST 275
#define POLY 276
#define INTEGER 277
#define NATURAL 278
#define RATIONAL 279
#define REAL 280
#define STRING 281
#define FOREIGN 282
#define FILET 283
#define MUTEX 284
#define SEMAPHORE 285
#define CONTINUATION 286
#define THREAD 287
#define VOID 288
#define BOOL 289
#define FUNCTION 290
#define FUNC 291
#define EXCEPTION 292
#define RAISE 293
#define TYPEDEF 294
#define IMPORT 295
#define NEW 296
#define ANONINIT 297
#define NAMESPACE 298
#define PUBLIC 299
#define PROTECTED 300
#define EXTEND 301
#define WHILE 302
#define DO 303
#define FOR 304
#define SWITCH 305
#define BREAK 306
#define CONTINUE 307
#define RETURNTOK 308
#define FORK 309
#define CASE 310
#define DEFAULT 311
#define TWIXT 312
#define NAME 313
#define TYPENAME 314
#define NAMESPACENAME 315
#define COMMAND 316
#define NAMECOMMAND 317
#define TEN_NUM 318
#define OCTAL0_NUM 319
#define OCTAL_NUM 320
#define BINARY_NUM 321
#define HEX_NUM 322
#define TEN_FLOAT 323
#define OCTAL0_FLOAT 324
#define OCTAL_FLOAT 325
#define BINARY_FLOAT 326
#define HEX_FLOAT 327
#define CHAR_CONST 328
#define STRING_CONST 329
#define POLY_CONST 330
#define THREAD_CONST 331
#define COMMENT_CONST 332
#define VOIDVAL 333
#define BOOLVAL 334
#define DARROW 335
#define POUND 336
#define COMMA 337
#define ASSIGN 338
#define ASSIGNPLUS 339
#define ASSIGNMINUS 340
#define ASSIGNTIMES 341
#define ASSIGNDIVIDE 342
#define ASSIGNDIV 343
#define ASSIGNMOD 344
#define ASSIGNPOW 345
#define ASSIGNSHIFTL 346
#define ASSIGNSHIFTR 347
#define ASSIGNLXOR 348
#define ASSIGNLAND 349
#define ASSIGNLOR 350
#define ASSIGNOR 351
#define ASSIGNAND 352
#define QUEST 353
#define COLON 354
#define OR 355
#define AND 356
#define LOR 357
#define LXOR 358
#define LAND 359
#define EQ 360
#define NE 361
#define LT 362
#define GT 363
#define LE 364
#define GE 365
#define SHIFTL 366
#define SHIFTR 367
#define PLUS 368
#define MINUS 369
#define TIMES 370
#define DIVIDE 371
#define DIV 372
#define POW 373
#define STARSTAR 374
#define POW2 375
#define POW3 376
#define UNIONCAST 377
#define UMINUS 378
#define BANG 379
#define FACT 380
#define LNOT 381
#define INC 382
#define DEC 383
#define STAR 384
#define AMPER 385
#define THREADID 386
#define OS 387
#define CS 388
#define DOT 389
#define ARROW 390
#define STAROS 391
#define CALL 392
#define OP 393
#define CP 394
#define POINTER 395
#define COLONCOLON 396
#define IF 397
#define TRY 398
#define NONL 399
#define ELSE 400
#define CATCH 401
#define NL 402
#define YYERRCODE 256
static const short yylhs[] = {                           -1,
    0,    0,   96,   96,   99,   99,   99,  100,  101,   98,
  102,  103,  103,  104,  104,  105,  105,   97,   97,   97,
   97,   97,   97,   97,    3,    3,    5,    5,    4,    7,
    7,    7,    6,    6,   27,   27,    1,    1,    2,    2,
   28,   28,   60,   60,  106,  107,    8,  108,  109,   14,
   14,   17,   17,   15,   15,   16,   16,   16,   16,   16,
   16,   16,   16,   16,   16,   16,   16,   16,   16,   16,
   16,  111,   16,   16,   16,   16,   70,   70,   19,   19,
   18,   12,   12,   13,    9,    9,  112,   10,   20,   20,
  110,  110,  113,   81,   82,   82,   21,   22,   22,   23,
   23,   24,   25,   25,   26,   26,   37,   37,   33,   33,
   35,   35,   40,   40,   34,   34,   36,   43,   38,   39,
   39,   39,   41,   41,   41,   42,   42,   42,   46,   46,
   46,   46,   46,   46,   45,   45,   45,   45,   45,   45,
   47,   47,   47,   47,   47,   47,   44,   44,   51,   51,
   51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
   51,   48,   48,   49,   49,   50,   50,   52,   52,   53,
   53,   54,   54,   56,   56,   55,   55,   55,   55,   57,
   57,   58,   58,   59,   59,   61,   61,   62,   62,   63,
   63,   66,   64,   64,   65,   65,   67,   67,   68,   68,
   69,   69,   71,   71,   77,   77,   72,   72,   73,   73,
   75,   75,   76,   76,   11,  114,   11,   74,   74,   74,
   74,   74,   74,   74,   74,   74,   74,   74,   74,   74,
   74,   74,   74,   74,   74,   74,   74,   74,   74,   74,
   74,   74,   74,   74,   74,   74,   74,   74,   74,   74,
   74,   74,   74,   74,   74,   74,   74,   74,   74,   74,
   74,   74,   74,   74,   74,   74,   74,   74,   74,   74,
   74,   74,   74,   74,   74,   74,   74,   74,   74,   74,
   74,   74,   74,   74,   74,   74,   74,   79,   79,   78,
   78,   78,   78,   78,   78,   78,   78,   78,   78,   78,
   78,   78,   78,   78,   80,   80,   80,   80,   80,   83,
   83,   83,   84,   84,   29,   29,   30,   30,   31,   32,
   85,   85,   86,   86,   87,   87,   87,   88,   89,   89,
   90,   90,   91,   91,   92,   93,   93,   94,   94,   94,
   94,   95,   95,   95,   95,
};
static const short yylen[] = {                            2,
    2,    0,    1,    3,    1,    1,    1,    0,    0,    0,
    0,    1,    0,    1,    0,    1,    0,    4,    6,    4,
    6,    6,    1,    1,    1,    0,    3,    1,    2,    1,
    1,    1,    3,    0,    2,    1,    2,    1,    1,    3,
    3,    2,    1,    1,    0,    0,    3,    2,    2,    2,
    0,    7,    9,    1,    1,    3,    9,   10,    9,    9,
   10,    2,    2,    3,    2,    1,    4,   10,    6,    6,
    7,    0,    9,    6,    2,   11,    3,    1,    1,    3,
    4,    2,    0,    7,    1,    1,    0,    2,    1,    4,
    1,    1,    0,    2,    1,    0,    3,    2,    0,    4,
    3,    3,    2,    0,    7,    3,    1,    0,    3,    1,
    3,    1,    1,    1,    4,    2,    1,    1,    4,    3,
    4,    4,    2,    2,    0,    4,    3,    2,    2,    4,
    4,    4,    4,    0,    2,    2,    2,    2,    2,    3,
    1,    4,    4,    4,    3,    1,    1,    0,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    0,    3,    1,    3,    1,    3,    1,    4,
    0,    4,    0,    1,    0,    1,    1,    1,    1,    1,
    0,    1,    1,    1,    1,    3,    2,    3,    2,    2,
    1,    3,    2,    1,    3,    2,    2,    1,    1,    0,
    1,    0,    1,    2,    1,    3,    1,    0,    3,    1,
    1,    0,    3,    2,    3,    0,    2,    3,    7,    2,
    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
    2,    2,    2,    3,    3,    3,    3,    3,    3,    3,
    2,    2,    3,    3,    5,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    2,    6,    8,    8,    8,    3,    6,    2,    1,
    3,    3,    4,    4,    4,    3,    3,    1,    0,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    2,    0,    5,    9,    2,    1,    3,    1,    1,    0,
    3,    1,    1,    1,    1,    2,    0,    4,    3,    1,
    3,    2,    1,    1,    4,    3,    1,    3,    3,    4,
    4,    1,    1,    1,    2,
};
static const short yydefred[] = {                         2,
    0,   10,   24,   23,    1,    3,    0,    0,    0,    0,
    0,   66,    0,   45,    0,  176,  177,  178,  179,  149,
  150,  151,  152,  153,  161,  154,  155,  156,  157,  158,
  159,  160,    8,    0,  182,  183,  185,    8,    8,    8,
    8,    0,    0,    0,    0,    8,   43,   36,    0,    0,
    0,  258,  260,  259,  261,  262,  263,  265,  264,  266,
  267,  268,  269,  270,  271,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  280,    0,    8,    8,  257,
   55,   10,   54,   46,    9,  146,    0,   93,   45,    0,
    0,    0,    0,  141,    0,    0,    0,    0,   38,    0,
    0,    0,    0,    0,    6,    7,    5,    4,    0,    0,
    0,  305,  307,  306,  308,  309,  220,   48,  279,  288,
    0,    0,    0,   45,   45,   45,   45,   62,   63,    0,
    0,    0,    0,    0,  201,    0,    0,   45,   42,   10,
  207,    0,   10,    0,   25,    0,  138,    0,  139,    0,
    0,  136,    0,  137,    0,    0,    0,    0,    0,  272,
    0,    0,    0,    0,   45,    0,    0,    9,   75,   35,
    0,   37,    0,    0,    8,    0,    0,  204,    0,   45,
    0,    0,   12,  128,    0,    0,  135,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    8,    8,    8,
  174,    0,    8,   65,    0,    0,    0,  304,  290,  291,
  292,  293,  294,  295,  296,  297,  298,  299,  300,  301,
  302,  303,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  241,  242,  228,  230,  232,    0,    0,    0,
    0,    0,    0,    0,   46,    0,    0,    8,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  117,   64,    0,    0,    0,    0,   34,   30,   32,   31,
    0,    0,    0,    0,    0,    0,  282,    0,    0,  281,
    0,    0,   79,   83,   20,   56,   41,   86,   46,   85,
    0,   95,   94,    0,    0,    0,  120,    0,    0,    0,
  140,  277,  167,    0,    0,    0,    0,    0,  187,    0,
    0,    0,  129,  138,  139,  136,  137,    0,    0,  127,
    0,    0,    0,    0,    0,   10,   18,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  286,
  287,    0,    0,    0,  211,    0,    0,    0,   47,   50,
   45,    0,  142,    0,  143,    0,  144,  122,    0,    0,
    0,    0,    0,    0,   14,    0,  209,    0,   27,   33,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   67,   89,   88,    0,  119,    0,    0,  193,    0,  121,
    0,    0,  342,  344,  343,  124,  118,    0,    8,   93,
    0,    0,    0,    0,    0,  190,  186,  199,    0,  189,
  145,   45,  114,    0,    0,    0,    0,    0,    0,  126,
   44,   72,    0,    0,  284,  283,    0,  214,  285,   49,
    0,    0,    0,  109,    0,    0,    0,    0,    0,    0,
    0,   21,   22,   45,  164,   45,   45,  168,    0,   46,
    0,   80,    0,   82,    0,  197,    0,  196,  345,    0,
    0,    0,    0,    0,    0,  322,    0,  330,    0,  337,
  324,  115,    0,    0,  133,  130,  166,  131,  132,  188,
    0,    9,    0,  113,    0,    0,    9,    0,   19,    0,
  213,    0,  170,  172,   69,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  273,    0,   45,    0,  195,
    0,    0,  332,  334,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  192,   46,    0,    0,   46,   70,  111,
    9,   40,   74,    0,    0,   46,    0,   77,   46,   46,
    0,    0,    0,   46,  325,    0,   46,    0,   46,  310,
    0,    0,   90,    0,  339,  319,  320,    0,    0,  331,
    0,  321,    0,    0,  329,  328,    0,    0,  336,  335,
  219,    0,  217,   93,   71,    0,    0,    9,   46,    9,
    9,    0,    0,   46,    0,    0,  326,  276,  274,  311,
  275,    0,   93,    0,    0,    0,  341,  313,    0,    0,
    9,   46,    0,   57,    9,   59,   60,    0,    0,   97,
   98,   46,   53,    0,    0,  317,    9,   73,    9,   45,
    0,   46,    0,   58,    0,  101,    9,   46,    0,  316,
   46,   68,   61,    0,    0,  102,  103,  100,   76,   84,
  315,    0,    0,  106,  314,  107,    0,    0,   46,  105,
};
static const short yydgoto[] = {                          1,
   80,  439,  143,  144,  145,  146,  281,   81,  299,  300,
  545,  400,  474,  255,  256,   83,   84,   85,  294,  403,
  560,  604,  605,  622,  642,  643,   86,   87,  651,  577,
  578,  614,  264,  178,  435,  179,  667,   88,   89,  436,
  309,   90,  418,   91,  136,  187,   93,  315,  284,  317,
   94,  285,  260,  262,   95,  202,   96,   97,   98,   99,
  188,  321,  322,  304,  408,  420,  409,  430,  458,  459,
  257,  140,  141,  101,  364,  365,  102,  253,  119,  117,
  173,  303,  569,  413,  485,  486,  564,  414,  487,  488,
  533,  415,  489,  490,  491,    5,    6,    8,  108,  305,
  169,    7,  184,  386,  539,  118,  368,  103,  369,  104,
  508,  301,  174,  547,
};
static const short yysindex[] = {                         0,
 -246,    0,    0,    0,    0,    0, 1216, -241, -214, -158,
 -109,    0,  145,    0,  145,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   59,    0,    0,    0,    0,    0,    0,
    0, -220, -207, 5280, 6450,    0,    0,    0, -191, 6450,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 6450, 6450, 6450, 6450, 6450,
 6450, 6450, 6450, 6450, -165,    0, 5150,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  181,    0,    0,   -4,
   25,  -45,  -61,    0, 6605,  144,  138,   33,    0, -204,
 6947,    3, 1350,   44,    0,    0,    0,    0, 6605, 6605,
   49,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   52,  -12,  102,    0,    0,    0,    0,    0,    0, -158,
 -109,   55,  138,  106,    0,  -22, 2122,    0,    0,    0,
    0, 1880,    0,   58,    0,  193,    0,  277,    0,  277,
  277,    0,  277,    0,  277,  277,  277,  277,  277,    0,
 5800,    4,  -51,   38,    0, 1484,   45,    0,    0,    0,
   39,    0,  175,  123,    0,  147,   79,    0,  140,    0,
 6605,  163,    0,    0, 5930, 3963,    0,  -61, -191, 6605,
 6605, 6605, 6605, 6605,   20,   45,  114,    0,    0,    0,
    0, 6605,    0,    0, 5280,   81, 6450,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 6450, 6450, 6450, 6450, 6450, 6450, 6450, 6450,
 6450, 6450, 6450, 6450, 6450, 6450, 6450, 6450, 6450, 6450,
 6450, 6450,    0,    0,    0,    0,    0, 6450,  172,  174,
 6450, 6450, 6450, 6450,    0, 1350,  227,    0,   49,  232,
   49,  236,  178,  250,  126, 6450,  128, 1350,  132,  136,
    0,    0,  137,  261, 6450,  261,    0,    0,    0,    0,
  141, 6450,  -41, -110,  146, 2010,    0,  219,    0,    0,
  142, 1350,    0,    0,    0,    0,    0,    0,    0,    0,
  266,    0,    0,  150, 6605,  148,    0, 6060,  202,  153,
    0,    0,    0,   36,  152,  211,  -82,  161,    0, -222,
  156, -185,    0,    0,    0,    0,    0, -177,   39,    0,
  238, 6565,   59,   45,  108,    0,    0,  306, 6776, 2233,
 2344, 2455, 2566,  608,  759,  759,  945,  945,  945,  945,
 1057, 1057,  898,  898,  306,  306,  306,  306,  164,    0,
    0,  165, 6719,  160,    0, 6947, 6947,  287,    0,    0,
    0,  291,    0,  292,    0,   49,    0,    0,  166, 5280,
  262, 5280, 5280, 5280,    0,  168,    0,  170,    0,    0,
  169,  195,  173,  182, 6450,  184,  308, 5280,  311,  186,
    0,    0,    0,  245,    0,  276,  114,    0, -184,    0,
 5410, 6947,    0,    0,    0,    0,    0,   55,    0,    0,
  -61,  -61,  321,  -61,  -61,    0,    0,    0, 6605,    0,
    0,    0,    0,    0,  327,  257,    1,  259,  335,    0,
    0,    0,  199, 6450,    0,    0, 6450,    0,    0,    0,
  209, 6605, 6605,    0,  339,  213,  217,  348,  220,  224,
  354,    0,    0,    0,    0,    0,    0,    0, 6450,    0,
  229,    0,   59,    0, 6450,    0, 6605,    0,    0,  283,
 6060, -165,  312, 6833,  289,    0,  290,    0,  293,    0,
    0,    0,  230,    0,    0,    0,    0,    0,    0,    0,
  239,    0,  115,    0,  369,   59,    0,  374,    0, 2122,
    0, 5280,    0,    0,    0, 1350, 5280, 5280, 1350,  266,
 5280,  375,  377,  378,  277,    0, 1350,    0, 1619,    0,
 6060, 6947,    0,    0,  333,  309, 6060, 6060,  379, 6190,
  382, -218,  389,    0,    0,  320,  266,    0,    0,    0,
    0,    0,    0, 1350,  268,    0,  269,    0,    0,    0,
  133,  271, 5540,    0,    0, 6320,    0, 5670,    0,    0,
  273,  153,    0, 6947,    0,    0,    0,  337, 6060,    0,
 6947,    0,  415, 6833,    0,    0,  283,  312,    0,    0,
    0, 6450,    0,    0,    0,  418,  266,    0,    0,    0,
    0, 5280,  344,    0,  133, 1350,    0,    0,    0,    0,
    0, 1350,    0,  299,  333, 6947,    0,    0, 6947,  426,
    0,    0,  158,    0,    0,    0,    0,  346, 1350,    0,
    0,    0,    0,  266, -200,    0,    0,    0,    0,    0,
  347,    0,  158,    0, 1350,    0,    0,    0, 6060,    0,
    0,    0,    0,  390, 1350,    0,    0,    0,    0,    0,
    0,  424,  394,    0,    0,    0,  355, 1350,    0,    0,
};
static const short yyrindex[] = {                         0,
 1082,    0,    0,    0,    0,    0,  159,    0,    0,  403,
  405,    0,    0,    0, 1554,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   42,  420,    0,    0,    0, 1684, -208,
 -233,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  420,  420,  420,  420,  420,
  420,  420,  420,  420,    0,    0,  420,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  -91,  338,    0, -178,  414,  908,    0,    0,  316,
 -247, -230,  139,    0,    0,    0,    0,    0, -216,   15,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  948,    0,    0,  431, 5006,    0,    0,    0,
    0, -254,    0, -253,    0,    0,    0, 2074,    0, 2186,
 2298,    0, 2410,    0, 2522, 2634, 2746, 2858, 2970,    0,
  420,    0, -121,    0,    0,  159,  784,    0,    0,    0,
 1684,    0, -149,  -56,    0,    0, -209,    0,  -44,    0,
    0,    0,    0,    0, -243,    0,    0,  338,    0,    0,
    0,    0,    0,    0,    0,    6, -176,    0,    0,    0,
    0, -178,    0,    0,  420,    0,  420,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  420,  420,  420,  420,  420,  420,  420,  420,
  420,  420,  420,  420,  420,  420,  420,  420,  420,  420,
  420,  420,    0,    0,    0,    0,    0,  420,    0,    0,
  420, -269,  420,  420,    0,   91,    0,    0,    0,    0,
    0,    0,   26,    0,    0, -244,    0,  159,    0,    0,
    0,    0,    0,  322,  420,  322,    0,    0,    0,    0,
 -229, -272,  431,    0,    0,  342,    0,    0,  326,    0,
    0,  139,    0,    0,    0,    0,    0,    0,    0,    0,
  385,    0,    0,    0, -279,    0,    0,  420,  -57,    0,
    0,    0,    0,  431,    0,  343,    0,    0,    0, -226,
    0,  340,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    6,    0,    0,    0, 3194,    0, 4915,
 4893, 4800, 4776, 4679, 4554, 4651, 4150, 4251, 4352, 4453,
 3944, 4047, 3734, 3839, 3302, 3410, 3518, 3626,    0,    0,
    0,    0,  340,    0,    0, -237,  -15,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  420,
    0, -197,  420,   42,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  420, 6890,    0,  420,    0,  488,
    0,    0,    0,    0,    0,    0, -131,    0,  340,    0,
  420,   24,    0,    0,    0,    0,    0,    0,    0,    0,
  338,  338,    0,  338,  338,    0,    0,    0,    0,    0,
    0,    0,    0,   16,    0,  468,    0,  470,    0,    0,
    0,    0,    0,  420,    0,    0,  420,    0,    0,    0,
    0, -216,   15,    0,    0,    0,    0,  345,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  420,    0,
    0,    0,    0,    0,  420,    0,  423,    0,    0, 1748,
  420,  425, 6662,   -1,  188,    0,  469,    0,  469,    0,
    0,    0,    0, -125,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 5026,
    0,  420,    0,    0,    0,  159,  420, -197,  159,    0,
 -227, 1814,    0, 1944, 3082,    0,  159,    0,    0,    0,
  420, -245,    0,    0,    0,    0,  420,  129,  474,   50,
    0,  477,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  139,    0,    0,    0,    0,    0,    0,
  478,    0,  420,    0,    0,  420,    0,  420,    0,    0,
  633,    0,    0, -175,    0,    0,    0,  359,  420,    0,
   -1,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  420,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  420,    0,    0,  478,  159,    0,    0,    0,    0,
    0,  159,    0,    0,    0, -127,    0,    0, -134,    0,
    0,    0,  484,    0,    0,    0,    0,    0,   91,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  484,    0,   91,    0,    0,    0,  420,    0,
    0,    0,    0,    0,   91,    0,    0,    0,    0,    0,
    0,    0,  404,    0,    0,    0,    0,   91,    0,    0,
};
static const short yygindex[] = {                         0,
  -25,  260,    0,    0,  508,    0,    0,  -76,    0,    0,
    0,    0,    0, -249,   -3,  652,    0,    0,    0,    0,
    0,  214,    0,    0,  177,    0,    0,  109,    0,  208,
    0,    0, -232,  406, -327,    0,    0,    0,    0,    0,
    0,  -28,    0,  -89,   -7, -148,    0,    0,  640,    0,
    0, -147,  376,  373,  155,    0,    0,  119,    0,  -84,
  328,  398,    0,  411,  356,  263,    0, -358,  -42,  313,
   10,  566,  559,    5,    0,  392,    0,    0,    0,  825,
 -406,    0,    0,  -26,    0, -523,    0,  323,    0,  302,
  314,    0,    0,  301, -267,    0,    0,  -74,    0,  638,
  104,    0, -154,  570,  -14,   -5,   21, -474, -338,    0,
    0,    0,    0,    0,
};
#define YYTABLESIZE 7340
static const short yytable[] = {                         92,
  162,  134,  172,   82,  448,  196,  370,  167,  122,    2,
  210,   28,  295,  494,  582,  132,  100,  205,  148,  259,
  261,  148,  333,  105,    3,  206,  372,  218,  374,  106,
  218,   26,  218,  148,  203,   29,   92,  318,  172,  323,
  416,  330,  399,  191,  128,  561,  148,  148,  132,  137,
  478,  171,  109,  135,  142,  117,  208,  129,  147,  149,
  204,  152,  154,  148,  165,  274,   14,  202,  276,  163,
  148,  150,  151,  153,  155,  156,  157,  158,  159,   34,
   34,   34,  148,  175,  428,  428,  164,  197,  205,  205,
  426,  333,  338,  148,  587,   92,  148,  218,  218,  218,
  359,  197,  197,  362,  168,  203,  205,   29,  110,  505,
  191,  148,  334,  147,  194,  165,  218,   87,  267,  268,
  269,  270,  623,  203,  212,  661,  117,  117,  117,  470,
  215,  205,  273,  215,  148,  215,  147,  649,  198,  210,
  340,  216,  123,  454,  163,  181,  205,  210,   28,  208,
  218,  429,  477,  283,  205,    4,  218,  111,   92,  291,
  107,  338,  133,  203,  218,  286,  202,  191,   26,  147,
  588,  203,   29,  311,  310,  550,  132,  314,  320,  440,
  583,  147,  324,  325,  326,  327,  328,  620,   87,  286,
  181,   13,  117,  208,  197,  133,  202,   92,   13,  147,
  215,  215,  215,  195,  139,  198,  634,  116,   96,  340,
   96,  338,    9,  534,  336,  406,  431,  195,  195,  215,
  125,   13,  160,  148,  402,  147,  392,  339,  340,  341,
  342,  343,  344,  345,  346,  347,  348,  349,  350,  351,
  352,  353,  354,  355,  356,  357,  358,  468,   92,  206,
  442,  201,  286,  215,  423,  286,  363,  366,  367,  215,
   92,  443,  198,  575,  381,  630,  323,  215,  323,  534,
  142,  296,  495,  496,  152,  498,  499,  393,  116,  142,
  113,   96,  173,  397,   92,  176,  153,  201,  123,  195,
  110,  125,  125,  110,  195,   13,  116,  407,  195,  195,
  195,  195,  195,  656,  596,  424,  202,  438,  177,  125,
  195,  617,  412,  433,  504,  180,  181,   16,   13,  401,
  206,  206,  181,  133,  437,  185,  181,  148,   36,   36,
  203,  186,  148,  170,  329,  323,  116,  288,  206,  254,
  148,  461,  289,  182,  116,  181,  391,  182,  258,  125,
  183,  132,  113,  132,  132,  132,  183,  125,   51,  123,
  123,  263,  259,  261,  265,  451,  182,  271,  181,  132,
  272,   47,   92,   49,   92,   92,   92,  123,  206,  646,
  266,  148,  181,   36,  181,  181,  206,  406,  181,  456,
   92,  135,  460,  135,  277,  658,   16,  287,   16,  286,
   51,   51,   36,  181,  404,  664,   51,  471,   36,   16,
   17,   18,   19,  195,   47,  484,  171,  123,  669,  148,
   47,  320,  441,  421,  182,  123,  501,  433,  504,  148,
  181,  290,  181,  181,  297,  198,  181,  199,  200,  298,
  195,  123,  602,  603,  197,  197,  183,  528,  510,  148,
  181,  363,  181,  181,  302,   17,  181,   17,  522,  306,
  523,  524,  112,  113,  114,  115,  116,  640,  641,  407,
  593,  307,  541,  525,  543,  312,  535,  308,  562,  529,
  438,  181,  337,  132,  360,  532,  361,   81,  132,  132,
  526,  204,  132,   47,  170,  171,  567,  570,  133,  373,
  133,  133,  133,  375,   92,  278,  279,  280,   92,   92,
   92,   92,  556,   92,  376,  559,  133,  377,  378,   92,
  380,  555,  572,  571,  382,  385,  557,  135,  383,  384,
  135,  396,   14,  394,  398,  574,  390,  195,  417,  422,
  410,  532,  581,  405,  584,  419,   92,  392,  425,  427,
  432,  445,  446,  449,  450,  452,  453,  648,  650,  455,
  195,  195,  464,  457,  465,  591,  466,  584,  594,  462,
  581,  463,  581,  132,  411,  467,  598,  469,  472,  600,
  601,  123,  475,  616,  608,  195,  473,  609,  476,  611,
  497,  502,   45,  503,   92,  506,  619,  546,   92,  507,
  509,  512,  632,  515,   92,  549,  516,  134,  633,  517,
  553,  628,  518,  519,  123,  145,  145,  520,  521,  625,
  531,   92,  527,  544,  536,  538,  540,  134,  134,  542,
  133,  186,   52,  551,  654,  133,  133,   92,  145,  133,
  554,  563,  639,  566,  568,  576,  579,   92,  428,  586,
  134,  134,  647,  581,  595,  245,  590,  592,  246,  247,
   92,  597,  599,  248,  606,  249,  250,  251,  660,  252,
  121,  662,  612,  615,  134,  124,  125,  126,  127,  242,
  243,  244,  618,  138,  245,  621,  635,  246,  247,  670,
  637,  665,  248,  145,  249,  250,  251,  629,  252,  645,
  655,  624,  663,  626,  627,  134,  666,   91,  668,   92,
  148,  184,  145,  145,  145,  165,  166,   10,  145,  145,
  133,  147,    9,   15,  638,  134,  134,  145,  644,  169,
  162,  134,  112,  200,   39,  148,   17,   45,   78,  134,
  652,  200,  653,   81,   16,   99,  318,   81,   81,   81,
  659,  104,   81,   81,   81,   81,   81,  108,   81,   81,
   81,   81,   81,   81,   81,  552,   81,   81,   81,   81,
   81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
   81,   81,   81,   13,  389,   81,   81,   81,   81,   81,
   81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
   81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
   81,   81,   81,   81,   81,   81,   81,  293,  631,  657,
   81,   81,  636,  492,  316,  514,  500,  513,  548,  493,
  558,  379,  530,  387,  613,  331,  332,  333,  511,  120,
  335,  585,  589,   81,  565,  388,   81,    0,    0,    0,
  580,    0,    0,    0,    0,    0,   81,   81,    0,    0,
    0,   81,    0,    0,    0,    0,   81,    0,   81,   81,
   81,    0,    0,  207,   81,    0,   81,    0,    0,    0,
   81,    0,    0,    0,   81,   81,    0,   81,   52,   81,
    0,    0,   52,   52,   52,  371,    0,   52,   52,   52,
   52,   52,    0,   52,   52,   52,   52,   52,   52,   52,
    0,   52,   52,   52,   52,   52,   52,   52,   52,   52,
   52,   52,   52,   52,   52,   52,   52,   52,    0,    0,
   52,   52,   52,   52,   52,   52,   52,   52,   52,   52,
   52,   52,   52,   52,   52,   52,   52,   52,   52,   52,
   52,   52,   52,   52,   52,   52,   52,   52,   52,   52,
   52,   52,    0,    0,    0,   52,   52,  229,  230,  231,
  232,  233,  234,  235,  236,  237,  238,  239,  240,  241,
    0,  242,  243,  244,    0,    0,  245,    0,   52,  246,
  247,   52,    0,    0,  248,    0,  249,  250,  251,    0,
  252,   52,   52,    0,    0,    0,   52,    0,    0,    0,
    0,   52,    0,   52,   52,   52,    0,    0,    0,   52,
    0,   52,    0,    0,  207,   52,    0,    0,    0,   52,
   52,    0,    0,   52,   52,    0,    0,    0,    0,   13,
    0,    0,    0,   13,   13,   13,    0,    0,   13,   13,
   13,    0,   13,    0,   13,   13,   13,   13,   13,   13,
   13,    0,   13,   13,   13,   13,   13,   13,   13,   13,
   13,   13,   13,   13,   13,   13,   13,   13,   13,    0,
    0,   13,   13,   13,   13,   13,   13,   13,   13,   13,
   13,   13,   13,    0,    0,   13,   13,   13,   13,   13,
   13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
   13,   13,   13,    0,    0,    0,   13,   13,    0,    0,
  231,  232,  233,  234,  235,  236,  237,  238,  239,  240,
  241,    0,  242,  243,  244,    0,    0,  245,    0,   13,
  246,  247,   13,    0,    0,  248,    0,  249,  250,  251,
    0,  252,   13,   13,    0,    0,    0,   13,    0,    0,
    0,    0,   13,  207,   13,   13,   13,  175,  175,  175,
   13,    0,   13,    0,    0,    0,   13,    0,    0,    0,
   13,   13,    0,  175,  175,    0,  175,  175,  175,  175,
  175,  175,  175,  175,  175,  175,  175,  175,    0,  180,
    0,  180,  180,    0,    0,  180,    0,  175,  175,  175,
  207,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  175,  175,  175,  175,  175,    0,  175,  175,  175,  175,
  175,  175,  175,  175,  175,  175,  175,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  175,  175,  175,  175,    0,    0,  175,  239,  240,  241,
    0,  242,  243,  244,    0,    0,  245,  175,    0,  246,
  247,  175,    0,    0,  248,    0,  249,  250,  251,    0,
  252,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  175,    0,    0,  175,    0,    0,  175,    0,    0,  175,
  235,  236,  237,  238,  239,  240,  241,  175,  242,  243,
  244,  175,  207,  245,    0,    0,  246,  247,    0,    0,
    0,  248,    0,  249,  250,  251,    0,  252,    0,    0,
  175,   11,   11,   11,    0,    0,   11,   11,   11,  175,
   11,    0,    0,   11,   11,   11,   11,   11,   11,    0,
   11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
   11,   11,   11,   11,   11,   11,   11,    0,    0,   11,
   11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
   11,    0,    0,   11,   11,   11,   11,   11,   11,   11,
   11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
   11,    0,    0,    0,   11,   11,    0,    0,    0,    0,
    0,    0,    0,    0,  237,  238,  239,  240,  241,    0,
  242,  243,  244,    0,    0,  245,    0,   11,  246,  247,
   11,    0,    0,  248,    0,  249,  250,  251,    0,  252,
   11,   11,    0,    0,    0,   11,    0,    0,    0,    0,
   11,    0,   11,   11,   11,    0,    0,    0,   11,    0,
   11,    0,    0,    0,   11,    9,   10,   11,   11,   11,
   12,   13,   14,    0,   15,    0,    0,   16,   17,   18,
   19,   20,   21,    0,   22,   23,   24,   25,   26,   27,
   28,   29,   30,   31,   32,   33,    0,    0,   34,    0,
    0,    0,    0,    0,   35,   36,   37,   38,   39,   40,
   41,   42,   43,   44,   45,    0,    0,   46,   47,   48,
   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,
   59,   60,   61,   62,   63,    0,    0,    0,   64,   65,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   66,    0,    0,   67,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   68,   69,    0,    0,    0,   70,
    0,    0,    0,    0,   71,    0,   72,   73,   74,    0,
    0,    0,   75,    0,   76,    0,    0,    0,   77,    9,
   10,   11,   78,   79,   12,   13,   14,    0,   15,    0,
    0,   16,   17,   18,   19,   20,   21,    0,   22,   23,
   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,
    0,    0,   34,    0,    0,    0,    0,    0,   35,   36,
   37,   38,   39,   40,   41,   42,   43,   44,   45,    0,
    0,   46,   47,   48,   49,    0,    0,   52,   53,   54,
   55,   56,   57,   58,   59,   60,   61,   62,   63,    0,
    0,    0,   64,   65,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   66,    0,    0,   67,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   68,   69,
    0,    0,    0,   70,    0,    0,    0,    0,   71,    0,
   72,   73,   74,    0,    0,    0,   75,    0,   76,    0,
    0,    0,   77,    9,   10,   11,   78,   79,   12,   13,
  292,    0,   15,    0,    0,   16,   17,   18,   19,   20,
   21,    0,   22,   23,   24,   25,   26,   27,   28,   29,
   30,   31,   32,   33,    0,    0,   34,    0,    0,    0,
    0,    0,   35,   36,   37,   38,   39,   40,   41,   42,
   43,   44,   45,    0,    0,   46,   47,   48,   49,    0,
    0,   52,   53,   54,   55,   56,   57,   58,   59,   60,
   61,   62,   63,    0,    0,    0,   64,   65,  289,  289,
    0,  289,    0,  289,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   66,
    0,    0,   67,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   68,   69,    0,    0,    0,   70,    0,    0,
    0,    0,   71,    0,   72,   73,   74,    0,    0,    0,
   75,    0,   76,    0,    0,    0,   77,    0,    0,    0,
   78,   79,    0,  573,  207,    0,    0,    0,  289,  289,
  289,  289,  289,  289,  289,  289,  289,  289,  289,  289,
  289,  289,  289,  289,  289,  289,  289,  289,  289,  289,
  289,  289,  289,  289,  289,  289,  289,  289,  289,  289,
  289,  289,  289,  289,  289,  289,    0,  289,  289,  289,
    0,    0,  289,    0,    0,  289,  289,    0,    0,    0,
  289,  289,  289,  289,  289,    0,  289,  289,   44,   44,
    0,   44,    0,   44,    0,  289,  208,  209,  210,  211,
  212,  213,  214,  215,  216,  217,  218,  219,  220,  221,
  222,  223,    0,  224,  225,  226,  227,  228,  229,  230,
  231,  232,  233,  234,  235,  236,  237,  238,  239,  240,
  241,    0,  242,  243,  244,    0,    0,  245,    0,    0,
  246,  247,    0,    0,    0,  248,    0,  249,  250,  251,
    0,  252,    0,   43,    0,   43,    0,   43,   44,   44,
   44,   44,   44,   44,   44,   44,   44,   44,   44,   44,
   44,   44,   44,   44,   44,   44,   44,   44,   44,   44,
   44,   44,   44,   44,   44,   44,   44,   44,   44,   44,
   44,   44,   44,   44,   44,   44,    0,   44,   44,   44,
    0,    0,   44,    0,    0,   44,   44,    0,    0,    0,
   44,   44,   44,   44,   44,    0,   44,   44,  327,  327,
    0,  327,   43,  327,   43,   44,   43,   43,   43,   43,
   43,   43,   43,   43,   43,   43,   43,   43,   43,   43,
   43,    0,   43,   43,   43,   43,   43,   43,   43,   43,
   43,   43,   43,   43,   43,   43,   43,   43,   43,   43,
    0,   43,   43,   43,    0,    0,   43,    0,    0,   43,
   43,    0,    0,    0,   43,    0,   43,   43,   43,    0,
   43,    0,    0,    0,    0,  207,    0,    0,  327,  327,
  327,  327,  327,  327,  327,  327,  327,  327,  327,  327,
  327,  327,  327,  327,  327,  327,  327,  327,  327,  327,
  327,  327,  327,  327,  327,  327,  327,  327,  327,  327,
  327,  327,  327,  327,  327,  327,    0,  327,  327,  327,
    0,    0,  327,    0,    0,  327,  327,    0,    0,    0,
  327,  327,  327,  327,  327,    0,  327,  327,  312,  312,
    0,  312,    0,  312,    0,  327,  275,  208,  209,  210,
  211,  212,  213,  214,  215,  216,  217,  218,  219,  220,
  221,  222,  223,    0,  224,  225,  226,  227,  228,  229,
  230,  231,  232,  233,  234,  235,  236,  237,  238,  239,
  240,  241,    0,  242,  243,  244,    0,    0,  245,    0,
    0,  246,  247,    0,    0,    0,  248,    0,  249,  250,
  251,    0,  252,    0,    0,  207,    0,    0,  312,  312,
  312,  312,  312,  312,  312,  312,  312,  312,  312,  312,
  312,  312,  312,  312,  312,  312,  312,  312,  312,  312,
  312,  312,  312,  312,  312,  312,  312,  312,  312,  312,
  312,  312,  312,  312,  312,  312,    0,  312,  312,  312,
    0,    0,  312,    0,    0,  312,  312,    0,    0,    0,
  312,  312,  312,  312,  312,    0,  312,  312,  224,  224,
    0,  224,    0,  224,    0,  312,  395,  208,  209,  210,
  211,  212,  213,  214,  215,  216,  217,  218,  219,  220,
  221,  222,  223,    0,  224,  225,  226,  227,  228,  229,
  230,  231,  232,  233,  234,  235,  236,  237,  238,  239,
  240,  241,    0,  242,  243,  244,    0,  207,  245,    0,
    0,  246,  247,    0,    0,    0,  248,    0,  249,  250,
  251,    0,  252,    0,    0,    0,    0,    0,  224,  224,
  224,  224,  224,  224,  224,  224,  224,  224,  224,  224,
  224,  224,  224,  224,  224,  224,  224,  224,  224,  224,
  224,  224,  224,  224,  224,  224,  224,  224,  224,  224,
  224,  224,  224,  224,  224,  224,    0,  224,  224,  224,
  223,  223,    0,  223,    0,  223,    0,    0,    0,    0,
    0,  224,    0,    0,    0,    0,    0,  224,    0,    0,
    0,    0,    0,    0,  223,  224,  224,  225,  226,  227,
  228,  229,  230,  231,  232,  233,  234,  235,  236,  237,
  238,  239,  240,  241,    0,  242,  243,  244,  207,    0,
  245,    0,    0,  246,  247,    0,    0,    0,  248,    0,
  249,  250,  251,    0,  252,    0,    0,    0,    0,    0,
  223,  223,  223,  223,  223,  223,  223,  223,  223,  223,
  223,  223,  223,  223,  223,  223,  223,  223,  223,  223,
  223,  223,  223,  223,  223,  223,  223,  223,  223,  223,
  223,  223,  223,  223,  223,  223,  223,  223,    0,  223,
  223,  223,  225,  225,    0,  225,    0,  225,    0,    0,
    0,    0,    0,  223,    0,    0,    0,    0,    0,  223,
    0,    0,    0,    0,    0,    0,    0,  223,  225,  226,
  227,  228,  229,  230,  231,  232,  233,  234,  235,  236,
  237,  238,  239,  240,  241,    0,  242,  243,  244,  207,
    0,  245,    0,    0,  246,  247,    0,    0,    0,  248,
    0,  249,  250,  251,    0,  252,    0,    0,    0,    0,
    0,    0,  225,  225,  225,  225,  225,  225,  225,  225,
  225,  225,  225,  225,  225,  225,  225,  225,  225,  225,
  225,  225,  225,  225,  225,  225,  225,  225,  225,  225,
  225,  225,  225,  225,  225,  225,  225,  225,  225,  225,
    0,  225,  225,  225,  221,  221,    0,  221,    0,  221,
    0,    0,    0,    0,    0,  225,    0,    0,    0,    0,
    0,  225,    0,    0,    0,    0,    0,    0,    0,  225,
  226,  227,  228,  229,  230,  231,  232,  233,  234,  235,
  236,  237,  238,  239,  240,  241,    0,  242,  243,  244,
  207,    0,  245,    0,    0,  246,  247,    0,    0,    0,
  248,    0,  249,  250,  251,    0,  252,    0,    0,    0,
    0,    0,    0,    0,  221,  221,  221,  221,  221,  221,
  221,  221,  221,  221,  221,  221,  221,  221,  221,  221,
  221,  221,  221,  221,  221,  221,  221,  221,  221,  221,
  221,  221,  221,  221,  221,  221,  221,  221,  221,  221,
  221,  221,    0,  221,  221,  221,  222,  222,    0,  222,
    0,  222,    0,    0,    0,    0,    0,  221,    0,    0,
    0,    0,    0,  221,    0,    0,    0,    0,    0,    0,
    0,  221,  227,  228,  229,  230,  231,  232,  233,  234,
  235,  236,  237,  238,  239,  240,  241,    0,  242,  243,
  244,  207,    0,  245,    0,    0,  246,  247,    0,    0,
    0,  248,    0,  249,  250,  251,    0,  252,    0,    0,
    0,    0,    0,    0,    0,    0,  222,  222,  222,  222,
  222,  222,  222,  222,  222,  222,  222,  222,  222,  222,
  222,  222,  222,  222,  222,  222,  222,  222,  222,  222,
  222,  222,  222,  222,  222,  222,  222,  222,  222,  222,
  222,  222,  222,  222,    0,  222,  222,  222,  227,  227,
    0,  227,    0,  227,    0,    0,    0,    0,    0,  222,
    0,    0,    0,    0,    0,  222,    0,    0,    0,    0,
    0,    0,    0,  222,  228,  229,  230,  231,  232,  233,
  234,  235,  236,  237,  238,  239,  240,  241,    0,  242,
  243,  244,    0,    0,  245,    0,    0,  246,  247,    0,
    0,    0,  248,    0,  249,  250,  251,    0,  252,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  227,  227,
  227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
  227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
  227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
  227,  227,  227,  227,  227,  227,    0,  227,  227,  227,
  226,  226,    0,  226,    0,  226,    0,    0,    0,    0,
    0,  227,    0,    0,    0,    0,    0,  227,    0,    0,
    0,    0,    0,    0,    0,  227,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  226,  226,  226,  226,  226,  226,  226,  226,  226,  226,
  226,  226,  226,  226,  226,  226,  226,  226,  226,  226,
  226,  226,  226,  226,  226,  226,  226,  226,  226,  226,
  226,  226,  226,  226,  226,  226,  226,  226,    0,  226,
  226,  226,  229,  229,    0,  229,    0,  229,    0,    0,
    0,    0,    0,  226,    0,    0,    0,    0,    0,  226,
    0,    0,    0,    0,    0,    0,    0,  226,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  229,  229,  229,  229,  229,  229,  229,  229,
  229,  229,  229,  229,  229,  229,  229,  229,  229,  229,
  229,  229,  229,  229,  229,  229,  229,  229,  229,  229,
  229,  229,  229,  229,  229,  229,  229,  229,  229,  229,
    0,  229,  229,  229,  231,  231,    0,  231,    0,  231,
    0,    0,    0,    0,    0,  229,    0,    0,    0,    0,
    0,  229,    0,    0,    0,    0,    0,    0,    0,  229,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  231,  231,  231,  231,  231,  231,
  231,  231,  231,  231,  231,  231,  231,  231,  231,  231,
  231,  231,  231,  231,  231,  231,  231,  231,  231,  231,
  231,  231,  231,  231,  231,  231,  231,  231,  231,  231,
  231,  231,    0,  231,  231,  231,  278,  278,    0,  278,
    0,  278,    0,    0,    0,    0,    0,  231,    0,    0,
    0,    0,    0,  231,    0,    0,    0,    0,    0,    0,
    0,  231,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  278,  278,  278,  278,
  278,  278,  278,  278,  278,  278,  278,  278,  278,  278,
  278,  278,  278,  278,  278,  278,  278,  278,  278,  278,
  278,  278,  278,  278,  278,  278,  278,  278,  278,  278,
  278,  278,  278,  278,    0,  278,  278,  278,  239,  239,
    0,  239,    0,  239,    0,    0,    0,    0,    0,  278,
    0,    0,    0,    0,    0,  278,    0,    0,    0,    0,
    0,    0,    0,  278,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  239,  239,
  239,  239,  239,  239,  239,  239,  239,  239,  239,  239,
  239,  239,  239,  239,  239,  239,  239,  239,  239,  239,
  239,  239,  239,  239,  239,  239,  239,  239,  239,  239,
  239,  239,  239,  239,  239,  239,  236,  236,    0,  236,
    0,  236,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  239,    0,    0,    0,    0,    0,  239,    0,    0,
    0,    0,    0,    0,    0,  239,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  236,  236,  236,  236,
  236,  236,  236,  236,  236,  236,  236,  236,  236,  236,
  236,  236,  236,  236,  236,  236,  236,  236,  236,  236,
  236,  236,  236,  236,  236,  236,  236,  236,  236,  236,
  236,  236,  236,  236,  237,  237,    0,  237,    0,  237,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  236,
    0,    0,    0,    0,    0,  236,    0,    0,    0,    0,
    0,    0,    0,  236,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  237,  237,  237,  237,  237,  237,
  237,  237,  237,  237,  237,  237,  237,  237,  237,  237,
  237,  237,  237,  237,  237,  237,  237,  237,  237,  237,
  237,  237,  237,  237,  237,  237,  237,  237,  237,  237,
  237,  237,  238,  238,    0,  238,    0,  238,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  237,    0,    0,
    0,    0,    0,  237,    0,    0,    0,    0,    0,    0,
    0,  237,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  238,  238,  238,  238,  238,  238,  238,  238,
  238,  238,  238,  238,  238,  238,  238,  238,  238,  238,
  238,  238,  238,  238,  238,  238,  238,  238,  238,  238,
  238,  238,  238,  238,  238,  238,  238,  238,  238,  238,
  240,  240,    0,  240,    0,  240,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  238,    0,    0,    0,    0,
    0,  238,    0,    0,    0,    0,    0,    0,    0,  238,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  240,  240,  240,  240,  240,  240,  240,  240,  240,  240,
  240,  240,  240,  240,  240,  240,  240,  240,  240,  240,
  240,  240,  240,  240,  240,  240,  240,  240,  240,  240,
  240,  240,  240,  240,  240,  240,  240,  240,  234,    0,
    0,  234,    0,  234,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  240,    0,    0,    0,    0,    0,  240,
    0,    0,    0,    0,    0,    0,    0,  240,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  234,  234,
  234,  234,  234,  234,  234,  234,  234,  234,  234,  234,
  234,  234,  234,  234,  234,  234,  234,  234,  234,  234,
  234,  234,  234,  234,  234,  234,  234,  234,  234,  234,
  234,  234,  234,  235,    0,    0,  235,    0,  235,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  234,    0,    0,    0,    0,    0,  234,    0,    0,
    0,    0,    0,    0,    0,  234,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  235,  235,  235,  235,  235,  235,  235,
  235,  235,  235,  235,  235,  235,  235,  235,  235,  235,
  235,  235,  235,  235,  235,  235,  235,  235,  235,  235,
  235,  235,  235,  235,  235,  235,  235,  235,  243,    0,
    0,  243,    0,  243,    0,    0,    0,    0,    0,    0,
    0,    0,    9,  130,  131,    0,  235,    0,    0,    0,
    0,    0,  235,    0,    0,    0,    0,    0,   20,   21,
  235,   22,   23,   24,   25,   26,   27,   28,   29,   30,
   31,   32,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   48,  189,  243,  243,
  243,  243,  243,  243,  243,  243,  243,  243,  243,  243,
  243,  243,  243,  243,  243,  243,  243,  243,  243,  243,
  243,  243,  243,  243,  243,  243,  243,  243,  243,  243,
  243,  244,    0,    0,  244,    0,  244,    0,  190,    0,
    0,  191,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  243,  192,    0,    0,    0,  193,  243,    0,    0,
    0,    0,    0,    0,    0,  243,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  194,  319,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  244,  244,  244,  244,  244,  244,  244,  244,  244,
  244,  244,  244,  244,  244,  244,  244,  244,  244,  244,
  244,  244,  244,  244,  244,  244,  244,  244,  244,  244,
  244,  244,  244,  244,  253,    0,    0,  253,    0,  253,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  244,    0,    0,    0,    0,    0,
  244,    0,    0,    0,    0,    0,    0,    0,  244,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  253,  253,  253,  253,  253,  253,
  253,  253,  253,  253,  253,  253,  253,  253,  253,  253,
  253,  253,  253,  253,  253,  253,  253,  253,  253,  253,
  253,  253,  253,  253,  253,  254,    0,    0,  254,    0,
  254,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  253,    0,    0,
    0,    0,    0,  253,    0,    0,    0,    0,    0,    0,
    0,  253,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  254,  254,  254,  254,  254,
  254,  254,  254,  254,  254,  254,  254,  254,  254,  254,
  254,  254,  254,  254,  254,  254,  254,  254,  254,  254,
  254,  254,  254,  254,  254,  254,  255,    0,    0,  255,
    0,  255,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  254,    0,
    0,    0,    0,    0,  254,    0,    0,    0,    0,    0,
    0,    0,  254,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  255,  255,  255,  255,
  255,  255,  255,  255,  255,  255,  255,  255,  255,  255,
  255,  255,  255,  255,  255,  255,  255,  255,  255,  255,
  255,  255,  255,  255,  255,  255,  255,  256,    0,    0,
  256,    0,  256,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  255,
    0,    0,    0,    0,    0,  255,    0,    0,    0,    0,
    0,    0,    0,  255,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  256,  256,  256,
  256,  256,  256,  256,  256,  256,  256,  256,  256,  256,
  256,  256,  256,  256,  256,  256,  256,  256,  256,  256,
  256,  256,  256,  256,  256,  256,  256,  256,  251,    0,
    0,  251,    0,  251,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  256,    0,    0,    0,    0,    0,  256,    0,    0,    0,
    0,    0,    0,    0,  256,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  251,  251,
  251,  251,  251,  251,  251,  251,  251,  251,  251,  251,
  251,  251,  251,  251,  251,  251,  251,  251,  251,  251,
  251,  251,  251,  251,  251,  252,    0,    0,  252,    0,
  252,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  251,    0,  247,    0,    0,  247,  251,  247,    0,
    0,    0,    0,    0,    0,  251,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  252,  252,  252,  252,  252,
  252,  252,  252,  252,  252,  252,  252,  252,  252,  252,
  252,  252,  252,  252,  252,  252,  252,  252,  252,  252,
  252,  252,    0,  247,  247,  247,  247,  247,  247,  247,
  247,  247,  247,  247,  247,  247,  247,  247,  247,  247,
  247,  247,  247,  247,  247,  247,  247,  247,  252,    0,
  246,    0,    0,  246,  252,  246,    0,    0,    0,    0,
    0,    0,  252,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  248,    0,  247,  248,    0,  248,
    0,    0,  247,    0,    0,    0,    0,    0,    0,    0,
  247,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  246,  246,  246,  246,  246,  246,  246,  246,  246,  246,
  246,  246,  246,  246,  246,  246,  246,  246,  246,  246,
  246,  246,  246,  246,  248,  248,  248,  248,  248,  248,
  248,  248,  248,  248,  248,  248,  248,  248,  248,  248,
  248,  248,  248,  248,  248,  248,  248,  249,    0,    0,
  249,    0,  249,  246,    0,    0,    0,    0,    0,  246,
    0,    0,    0,    0,    0,    0,    0,  246,    0,  250,
    0,    0,  250,    0,  250,    0,    0,  248,    0,    0,
    0,    0,    0,  248,    0,    0,    0,    0,    0,    0,
    0,  248,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  249,  249,  249,
  249,  249,  249,  249,  249,  249,  249,  249,  249,  249,
  249,  249,  249,  249,  249,  249,  249,  249,  249,  250,
  250,  250,  250,  250,  250,  250,  250,  250,  250,  250,
  250,  250,  250,  250,  250,  250,  250,  250,  250,  250,
  233,    0,    0,  233,    0,  233,    0,    0,    0,    0,
  249,    0,    0,    0,    0,    0,  249,    0,    0,    0,
  245,    0,    0,  245,  249,  245,    0,    0,    0,    0,
    0,    0,  250,    0,    0,    0,    0,    0,  250,    0,
    0,    0,    0,    0,    0,    0,  250,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  233,  233,  233,  233,  233,  233,  233,  233,  233,  233,
  233,  233,  233,  233,  233,  233,  233,  233,    0,  233,
  245,  245,  245,  245,  245,  245,  245,  245,  245,  245,
  245,  245,  245,  245,  245,  245,  245,  245,    0,  245,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  233,    0,    0,    0,    0,    0,  233,
    0,    0,    0,    0,    0,    0,    0,  233,    0,    9,
  130,  131,    0,  245,    0,   13,   14,    0,   15,  245,
    0,   16,   17,   18,   19,   20,   21,  245,   22,   23,
   24,   25,   26,   27,   28,   29,   30,   31,   32,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   35,   36,
    0,    0,    0,    0,    0,    0,    0,    0,   45,    0,
    0,    0,   47,   48,   49,    0,    0,   52,   53,   54,
   55,   56,   57,   58,   59,   60,   61,   62,   63,    0,
    0,    0,   64,   65,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   66,    0,    0,   67,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   68,   69,
    0,    0,    0,   70,    0,    0,    0,    0,   71,    0,
   72,   73,   74,    0,    0,    0,  161,    0,   76,    9,
  130,  131,   77,    0,    0,   13,    0,    0,   15,    0,
    0,   16,   17,   18,   19,   20,   21,    0,   22,   23,
   24,   25,   26,   27,   28,   29,   30,   31,   32,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   35,   36,
    0,    0,    0,    0,    0,    0,    0,    0,   45,    0,
    0,    0,   47,   48,   49,    0,    0,   52,   53,   54,
   55,   56,   57,   58,   59,   60,   61,   62,   63,    0,
    0,    0,   64,   65,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   66,    0,    0,   67,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   68,   69,
    0,    0,    0,   70,    0,    0,    0,    0,   71,    0,
   72,   73,   74,    0,    0,    0,   75,    0,   76,    9,
  130,  131,   77,    0,    0,   13,  411,  479,   15,    0,
    0,    0,    0,    0,    0,   20,   21,    0,   22,   23,
   24,   25,   26,   27,   28,   29,   30,   31,   32,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   45,    0,
    0,    0,  480,   48,   49,    0,    0,   52,   53,   54,
   55,   56,   57,   58,   59,   60,   61,   62,   63,    0,
    0,    0,   64,   65,  481,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   66,    0,    0,   67,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   68,   69,
    0,    0,    0,   70,    0,    0,    0,    0,   71,    0,
   72,   73,   74,    0,    0,    0,  482,    0,  483,    9,
  130,  131,   77,    0,    0,   13,    0,  607,   15,    0,
    0,    0,    0,    0,    0,   20,   21,    0,   22,   23,
   24,   25,   26,   27,   28,   29,   30,   31,   32,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   45,    0,
    0,    0,   47,   48,   49,    0,    0,   52,   53,   54,
   55,   56,   57,   58,   59,   60,   61,   62,   63,    0,
    0,    0,   64,   65,  481,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   66,    0,    0,   67,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   68,   69,
    0,    0,    0,   70,    0,    0,    0,    0,   71,    0,
   72,   73,   74,    0,    0,    0,   75,    0,   76,    9,
  130,  131,   77,    0,    0,   13,  411,  610,   15,    0,
    0,    0,    0,    0,    0,   20,   21,    0,   22,   23,
   24,   25,   26,   27,   28,   29,   30,   31,   32,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   45,    0,
    0,    0,   47,   48,   49,    0,    0,   52,   53,   54,
   55,   56,   57,   58,   59,   60,   61,   62,   63,    0,
    0,    0,   64,   65,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   66,    0,    0,   67,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   68,   69,
    0,    0,    0,   70,    0,    0,    0,    0,   71,    0,
   72,   73,   74,    0,    0,    0,  482,    0,   76,    9,
  130,  131,   77,    0,    0,   13,    0,    0,   15,    0,
    0,    0,    0,    0,    0,   20,   21,    0,   22,   23,
   24,   25,   26,   27,   28,   29,   30,   31,   32,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   45,    0,
    0,    0,   47,   48,   49,    0,    0,   52,   53,   54,
   55,   56,   57,   58,   59,   60,   61,   62,   63,    0,
    0,    0,   64,   65,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   66,    0,    0,   67,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   68,  282,
    0,    0,    0,   70,    0,    0,    0,    0,   71,    0,
   72,   73,   74,    0,    0,    0,   75,  160,   76,    9,
  130,  131,   77,    0,    0,   13,    0,    0,   15,  313,
    0,    0,    0,    0,    0,   20,   21,    0,   22,   23,
   24,   25,   26,   27,   28,   29,   30,   31,   32,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   45,    0,
    0,    0,   47,   48,   49,    0,    0,   52,   53,   54,
   55,   56,   57,   58,   59,   60,   61,   62,   63,    0,
    0,    0,   64,   65,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   66,    0,    0,   67,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   68,  282,
    0,    0,    0,   70,    0,    0,    0,    0,   71,    0,
   72,   73,   74,    0,    0,    0,   75,    0,   76,    9,
  130,  131,   77,    0,    0,   13,  411,    0,   15,    0,
    0,    0,    0,    0,    0,   20,   21,    0,   22,   23,
   24,   25,   26,   27,   28,   29,   30,   31,   32,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   45,    0,
    0,    0,   47,   48,   49,    0,    0,   52,   53,   54,
   55,   56,   57,   58,   59,   60,   61,   62,   63,    0,
    0,    0,   64,   65,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   66,    0,    0,   67,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   68,   69,
    0,    0,    0,   70,    0,    0,    0,    0,   71,    0,
   72,   73,   74,    0,    0,    0,   75,    0,   76,    9,
  130,  131,   77,    0,    0,   13,    0,    0,   15,    0,
    0,    0,    0,    0,    0,   20,   21,    0,   22,   23,
   24,   25,   26,   27,   28,   29,   30,   31,   32,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   45,    0,
    0,    0,   47,   48,   49,    0,    0,   52,   53,   54,
   55,   56,   57,   58,   59,   60,   61,   62,   63,    0,
    0,    0,   64,   65,  481,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   66,    0,    0,   67,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   68,   69,
    0,    0,    0,   70,    0,    0,    0,    0,   71,    0,
   72,   73,   74,    0,    0,    0,   75,    0,   76,    9,
  130,  131,   77,    0,    0,   13,  411,    0,   15,    0,
    0,    0,    0,    0,    0,   20,   21,    0,   22,   23,
   24,   25,   26,   27,   28,   29,   30,   31,   32,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   45,    0,
    0,    0,   47,   48,   49,    0,    0,   52,   53,   54,
   55,   56,   57,   58,   59,   60,   61,   62,   63,    0,
    0,    0,   64,   65,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   66,    0,    0,   67,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   68,   69,
    0,    0,    0,   70,    0,    0,    0,    0,   71,    0,
   72,   73,   74,    0,    0,    0,  482,    0,   76,    9,
  130,  131,   77,    0,    0,   13,    0,    0,   15,    0,
    0,    0,    0,    0,    0,   20,   21,    0,   22,   23,
   24,   25,   26,   27,   28,   29,   30,   31,   32,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   45,    0,
    0,    0,   47,   48,   49,    0,    0,   52,   53,   54,
   55,   56,   57,   58,   59,   60,   61,   62,   63,    0,
    0,    0,   64,   65,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   66,    0,    0,   67,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   68,   69,
    0,    0,    0,   70,    9,  130,  131,    0,   71,    0,
   72,   73,   74,    0,    0,    0,   75,    0,   76,    0,
   20,   21,   77,   22,   23,   24,   25,   26,   27,   28,
   29,   30,   31,   32,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    9,  130,  131,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  433,  434,  189,
   20,   21,    0,   22,   23,   24,   25,   26,   27,   28,
   29,   30,   31,   32,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   48,  189,
  190,    0,    0,  191,    0,    0,    0,  280,    0,  280,
    0,  280,    0,    0,  192,    0,    0,    0,  193,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  194,    0,    0,
  190,    0,    0,  191,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  192,    0,    0,    0,  193,    0,
    0,    0,    0,    0,  207,    0,    0,    0,  428,    0,
    0,    0,    0,    0,    0,    0,  280,  194,  280,  280,
  280,  280,  280,  280,  280,  280,  280,  280,  280,  280,
  280,  280,  280,  280,  280,    0,  280,  280,  280,  280,
  280,  280,  280,  280,  280,  280,  280,  280,  280,  280,
  280,  280,  280,  280,    0,  280,  280,  280,    0,    0,
  280,  207,    0,  280,  280,    0,    0,    0,  280,    0,
  280,  280,  280,    0,  280,  447,  208,  209,  210,  211,
  212,  213,  214,  215,  216,  217,  218,  219,  220,  221,
  222,  223,    0,  224,  225,  226,  227,  228,  229,  230,
  231,  232,  233,  234,  235,  236,  237,  238,  239,  240,
  241,    0,  242,  243,  244,    0,    0,  245,  207,    0,
  246,  247,    0,    0,    0,  248,    0,  249,  250,  251,
    0,  252,    0,  208,  209,  210,  211,  212,  213,  214,
  215,  216,  217,  218,  219,  220,  221,  222,  223,  444,
  224,  225,  226,  227,  228,  229,  230,  231,  232,  233,
  234,  235,  236,  237,  238,  239,  240,  241,    0,  242,
  243,  244,    0,    0,  245,  277,    0,  246,  247,    0,
    0,    0,  248,    0,  249,  250,  251,  537,  252,    0,
  208,  209,  210,  211,  212,  213,  214,  215,  216,  217,
  218,  219,  220,  221,  222,  223,    0,  224,  225,  226,
  227,  228,  229,  230,  231,  232,  233,  234,  235,  236,
  237,  238,  239,  240,  241,    0,  242,  243,  244,    0,
    0,  245,  207,    0,  246,  247,    0,    0,    0,  248,
    0,  249,  250,  251,    0,  252,  277,  277,  277,  277,
  277,  277,  277,  277,  277,  277,  277,  277,  277,  277,
  277,  277,  277,    0,  277,  277,  277,  277,  277,  277,
  277,  277,  277,  277,  277,  277,  277,  277,  277,  277,
  277,  277,    0,  277,  277,  277,    0,    0,  277,    0,
    0,  277,  277,    0,    0,    0,  277,    0,  277,  277,
  277,    0,  277,    0,  208,  209,  210,  211,  212,  213,
  214,  215,  216,  217,  218,  219,  220,  221,  222,  223,
    0,  224,  225,  226,  227,  228,  229,  230,  231,  232,
  233,  234,  235,  236,  237,  238,  239,  240,  241,    0,
  242,  243,  244,    0,    0,  245,    0,    0,  246,  247,
    0,    0,    0,  248,    0,  249,  250,  251,    0,  252,
};
static const short yycheck[] = {                          7,
   77,   44,   87,    7,  363,   95,  256,   82,   34,  256,
  265,  265,  167,  420,  538,   44,    7,  265,  291,  109,
  110,  291,  268,  265,  271,  100,  259,  265,  261,  271,
  268,  265,  270,  313,  265,  265,   44,  185,  123,  188,
  308,  196,  292,  270,  265,  520,  291,  291,   77,   45,
  409,  268,  267,   44,   50,  265,  265,  265,   66,   67,
  265,   69,   70,  291,  337,  140,  267,  265,  143,   77,
   66,   67,   68,   69,   70,   71,   72,   73,   74,  313,
  314,  315,  291,   89,  270,  270,   77,   95,  336,  337,
  313,  337,  268,  291,  313,  103,  313,  335,  336,  337,
  248,  109,  110,  251,   84,  336,  354,  337,  267,  437,
  337,  290,  202,  290,  394,  388,  354,  267,  124,  125,
  126,  127,  597,  354,  394,  649,  336,  337,  338,  397,
  265,  336,  138,  268,  313,  270,  313,  338,  270,  394,
  268,  267,   34,  376,  388,  368,  394,  402,  402,  394,
  388,  337,  337,  161,  402,  402,  394,  267,  166,  165,
  402,  337,   44,  394,  402,  161,  394,  394,  402,  291,
  389,  402,  402,  181,  180,  503,  205,  185,  186,  334,
  539,  313,  190,  191,  192,  193,  194,  594,  338,  185,
  368,  313,  402,  402,  202,   77,  394,  205,  290,  291,
  335,  336,  337,   95,  396,  337,  613,  265,  265,  337,
  267,  207,  338,  481,  205,  305,  394,  109,  110,  354,
  265,  313,  388,  402,  301,  402,  337,  223,  224,  225,
  226,  227,  228,  229,  230,  231,  232,  233,  234,  235,
  236,  237,  238,  239,  240,  241,  242,  395,  256,  265,
  335,   97,  248,  388,  337,  251,  252,  253,  254,  394,
  268,  336,  394,  531,  268,  604,  268,  402,  270,  537,
  266,  168,  421,  422,  282,  424,  425,  388,  336,  275,
  265,  338,  268,  289,  292,  290,  282,  133,  265,  181,
  265,  336,  337,  268,  186,  290,  354,  305,  190,  191,
  192,  193,  194,  642,  554,  388,  265,  333,  313,  354,
  202,  579,  308,  313,  314,  291,  368,  268,  313,  299,
  336,  337,  368,  205,  332,  387,  368,  313,  313,  314,
  298,  393,  291,  314,  315,  337,  394,  389,  354,  337,
  291,  384,  394,  389,  402,  368,  388,  389,  305,  394,
  402,  380,  337,  382,  383,  384,  402,  402,  268,  336,
  337,  313,  452,  453,  313,  371,  389,  313,  368,  398,
  265,  313,  380,  315,  382,  383,  384,  354,  394,  629,
  393,  291,  292,  368,  294,  295,  402,  477,  298,  380,
  398,  382,  383,  384,  337,  645,  268,  394,  270,  395,
  310,  311,  387,  368,  301,  655,  268,  398,  393,  272,
  273,  274,  275,  305,  313,  411,  315,  394,  668,  291,
  313,  429,  315,  388,  389,  402,  432,  313,  314,  291,
  292,  394,  294,  295,  396,  292,  298,  294,  295,  265,
  332,  333,  310,  311,  452,  453,  402,  473,  444,  291,
  292,  447,  294,  295,  332,  268,  298,  270,  464,  313,
  466,  467,  318,  319,  320,  321,  322,  310,  311,  477,
  547,  393,  487,  469,  489,  313,  482,  338,  521,  475,
  506,  368,  402,  512,  313,  481,  313,    0,  517,  518,
  470,  265,  521,  313,  314,  315,  523,  524,  380,  268,
  382,  383,  384,  268,  512,  313,  314,  315,  516,  517,
  518,  519,  516,  521,  337,  519,  398,  268,  393,  527,
  393,  512,  528,  527,  393,  265,  517,  518,  393,  393,
  521,  313,  267,  388,  393,  531,  396,  429,  337,  388,
  393,  537,  538,  394,  540,  393,  554,  337,  388,  394,
  313,  388,  388,  394,  268,  265,  265,  634,  635,  394,
  452,  453,  394,  302,  370,  545,  394,  563,  548,  402,
  566,  402,  568,  602,  267,  394,  556,  394,  268,  559,
  560,  473,  338,  579,  564,  477,  401,  567,  313,  569,
  270,  265,  267,  337,  602,  337,  592,  494,  606,  265,
  402,  393,  606,  265,  612,  502,  394,  270,  612,  393,
  507,  602,  265,  394,  506,  290,  291,  394,  265,  599,
  338,  629,  394,  394,  313,  337,  337,  290,  291,  337,
  512,  393,    0,  265,  640,  517,  518,  645,  313,  521,
  267,  267,  622,  267,  267,  313,  338,  655,  270,  268,
  313,  314,  632,  649,  551,  379,  268,  338,  382,  383,
  668,  394,  394,  387,  394,  389,  390,  391,  648,  393,
   33,  651,  400,  337,  337,   38,   39,   40,   41,  374,
  375,  376,  268,   46,  379,  268,  388,  382,  383,  669,
  265,  268,  387,  368,  389,  390,  391,  354,  393,  354,
  354,  598,  313,  600,  601,  368,  313,  305,  354,  305,
  291,  298,  387,  388,  389,   78,   79,  402,  393,  394,
  602,  291,  338,  402,  621,  388,  389,  402,  625,  388,
  388,  394,  265,  394,  265,  313,  268,  313,  394,  402,
  637,  268,  639,  256,  268,  268,  388,  260,  261,  262,
  647,  268,  265,  266,  267,  268,  269,  354,  271,  272,
  273,  274,  275,  276,  277,  506,  279,  280,  281,  282,
  283,  284,  285,  286,  287,  288,  289,  290,  291,  292,
  293,  294,  295,    0,  277,  298,  299,  300,  301,  302,
  303,  304,  305,  306,  307,  308,  309,  310,  311,  312,
  313,  314,  315,  316,  317,  318,  319,  320,  321,  322,
  323,  324,  325,  326,  327,  328,  329,  166,  605,  643,
  333,  334,  615,  418,  185,  453,  429,  452,  501,  419,
  518,  266,  477,  275,  572,  198,  199,  200,  447,   15,
  203,  540,  542,  356,  522,  276,  359,   -1,   -1,   -1,
  537,   -1,   -1,   -1,   -1,   -1,  369,  370,   -1,   -1,
   -1,  374,   -1,   -1,   -1,   -1,  379,   -1,  381,  382,
  383,   -1,   -1,  266,  387,   -1,  389,   -1,   -1,   -1,
  393,   -1,   -1,   -1,  397,  398,   -1,  400,  256,  402,
   -1,   -1,  260,  261,  262,  258,   -1,  265,  266,  267,
  268,  269,   -1,  271,  272,  273,  274,  275,  276,  277,
   -1,  279,  280,  281,  282,  283,  284,  285,  286,  287,
  288,  289,  290,  291,  292,  293,  294,  295,   -1,   -1,
  298,  299,  300,  301,  302,  303,  304,  305,  306,  307,
  308,  309,  310,  311,  312,  313,  314,  315,  316,  317,
  318,  319,  320,  321,  322,  323,  324,  325,  326,  327,
  328,  329,   -1,   -1,   -1,  333,  334,  360,  361,  362,
  363,  364,  365,  366,  367,  368,  369,  370,  371,  372,
   -1,  374,  375,  376,   -1,   -1,  379,   -1,  356,  382,
  383,  359,   -1,   -1,  387,   -1,  389,  390,  391,   -1,
  393,  369,  370,   -1,   -1,   -1,  374,   -1,   -1,   -1,
   -1,  379,   -1,  381,  382,  383,   -1,   -1,   -1,  387,
   -1,  389,   -1,   -1,  266,  393,   -1,   -1,   -1,  397,
  398,   -1,   -1,  401,  402,   -1,   -1,   -1,   -1,  256,
   -1,   -1,   -1,  260,  261,  262,   -1,   -1,  265,  266,
  267,   -1,  269,   -1,  271,  272,  273,  274,  275,  276,
  277,   -1,  279,  280,  281,  282,  283,  284,  285,  286,
  287,  288,  289,  290,  291,  292,  293,  294,  295,   -1,
   -1,  298,  299,  300,  301,  302,  303,  304,  305,  306,
  307,  308,  309,   -1,   -1,  312,  313,  314,  315,  316,
  317,  318,  319,  320,  321,  322,  323,  324,  325,  326,
  327,  328,  329,   -1,   -1,   -1,  333,  334,   -1,   -1,
  362,  363,  364,  365,  366,  367,  368,  369,  370,  371,
  372,   -1,  374,  375,  376,   -1,   -1,  379,   -1,  356,
  382,  383,  359,   -1,   -1,  387,   -1,  389,  390,  391,
   -1,  393,  369,  370,   -1,   -1,   -1,  374,   -1,   -1,
   -1,   -1,  379,  266,  381,  382,  383,  260,  261,  262,
  387,   -1,  389,   -1,   -1,   -1,  393,   -1,   -1,   -1,
  397,  398,   -1,  276,  277,   -1,  279,  280,  281,  282,
  283,  284,  285,  286,  287,  288,  289,  290,   -1,  292,
   -1,  294,  295,   -1,   -1,  298,   -1,  260,  261,  262,
  266,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  313,  314,  315,  276,  277,   -1,  279,  280,  281,  282,
  283,  284,  285,  286,  287,  288,  289,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  313,  314,  315,  356,   -1,   -1,  359,  370,  371,  372,
   -1,  374,  375,  376,   -1,   -1,  379,  370,   -1,  382,
  383,  374,   -1,   -1,  387,   -1,  389,  390,  391,   -1,
  393,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  393,   -1,   -1,  356,   -1,   -1,  359,   -1,   -1,  402,
  366,  367,  368,  369,  370,  371,  372,  370,  374,  375,
  376,  374,  266,  379,   -1,   -1,  382,  383,   -1,   -1,
   -1,  387,   -1,  389,  390,  391,   -1,  393,   -1,   -1,
  393,  260,  261,  262,   -1,   -1,  265,  266,  267,  402,
  269,   -1,   -1,  272,  273,  274,  275,  276,  277,   -1,
  279,  280,  281,  282,  283,  284,  285,  286,  287,  288,
  289,  290,  291,  292,  293,  294,  295,   -1,   -1,  298,
  299,  300,  301,  302,  303,  304,  305,  306,  307,  308,
  309,   -1,   -1,  312,  313,  314,  315,  316,  317,  318,
  319,  320,  321,  322,  323,  324,  325,  326,  327,  328,
  329,   -1,   -1,   -1,  333,  334,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  368,  369,  370,  371,  372,   -1,
  374,  375,  376,   -1,   -1,  379,   -1,  356,  382,  383,
  359,   -1,   -1,  387,   -1,  389,  390,  391,   -1,  393,
  369,  370,   -1,   -1,   -1,  374,   -1,   -1,   -1,   -1,
  379,   -1,  381,  382,  383,   -1,   -1,   -1,  387,   -1,
  389,   -1,   -1,   -1,  393,  260,  261,  262,  397,  398,
  265,  266,  267,   -1,  269,   -1,   -1,  272,  273,  274,
  275,  276,  277,   -1,  279,  280,  281,  282,  283,  284,
  285,  286,  287,  288,  289,  290,   -1,   -1,  293,   -1,
   -1,   -1,   -1,   -1,  299,  300,  301,  302,  303,  304,
  305,  306,  307,  308,  309,   -1,   -1,  312,  313,  314,
  315,  316,  317,  318,  319,  320,  321,  322,  323,  324,
  325,  326,  327,  328,  329,   -1,   -1,   -1,  333,  334,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  356,   -1,   -1,  359,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  369,  370,   -1,   -1,   -1,  374,
   -1,   -1,   -1,   -1,  379,   -1,  381,  382,  383,   -1,
   -1,   -1,  387,   -1,  389,   -1,   -1,   -1,  393,  260,
  261,  262,  397,  398,  265,  266,  267,   -1,  269,   -1,
   -1,  272,  273,  274,  275,  276,  277,   -1,  279,  280,
  281,  282,  283,  284,  285,  286,  287,  288,  289,  290,
   -1,   -1,  293,   -1,   -1,   -1,   -1,   -1,  299,  300,
  301,  302,  303,  304,  305,  306,  307,  308,  309,   -1,
   -1,  312,  313,  314,  315,   -1,   -1,  318,  319,  320,
  321,  322,  323,  324,  325,  326,  327,  328,  329,   -1,
   -1,   -1,  333,  334,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  356,   -1,   -1,  359,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  369,  370,
   -1,   -1,   -1,  374,   -1,   -1,   -1,   -1,  379,   -1,
  381,  382,  383,   -1,   -1,   -1,  387,   -1,  389,   -1,
   -1,   -1,  393,  260,  261,  262,  397,  398,  265,  266,
  267,   -1,  269,   -1,   -1,  272,  273,  274,  275,  276,
  277,   -1,  279,  280,  281,  282,  283,  284,  285,  286,
  287,  288,  289,  290,   -1,   -1,  293,   -1,   -1,   -1,
   -1,   -1,  299,  300,  301,  302,  303,  304,  305,  306,
  307,  308,  309,   -1,   -1,  312,  313,  314,  315,   -1,
   -1,  318,  319,  320,  321,  322,  323,  324,  325,  326,
  327,  328,  329,   -1,   -1,   -1,  333,  334,  265,  266,
   -1,  268,   -1,  270,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  356,
   -1,   -1,  359,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  369,  370,   -1,   -1,   -1,  374,   -1,   -1,
   -1,   -1,  379,   -1,  381,  382,  383,   -1,   -1,   -1,
  387,   -1,  389,   -1,   -1,   -1,  393,   -1,   -1,   -1,
  397,  398,   -1,  265,  266,   -1,   -1,   -1,  335,  336,
  337,  338,  339,  340,  341,  342,  343,  344,  345,  346,
  347,  348,  349,  350,  351,  352,  353,  354,  355,  356,
  357,  358,  359,  360,  361,  362,  363,  364,  365,  366,
  367,  368,  369,  370,  371,  372,   -1,  374,  375,  376,
   -1,   -1,  379,   -1,   -1,  382,  383,   -1,   -1,   -1,
  387,  388,  389,  390,  391,   -1,  393,  394,  265,  266,
   -1,  268,   -1,  270,   -1,  402,  338,  339,  340,  341,
  342,  343,  344,  345,  346,  347,  348,  349,  350,  351,
  352,  353,   -1,  355,  356,  357,  358,  359,  360,  361,
  362,  363,  364,  365,  366,  367,  368,  369,  370,  371,
  372,   -1,  374,  375,  376,   -1,   -1,  379,   -1,   -1,
  382,  383,   -1,   -1,   -1,  387,   -1,  389,  390,  391,
   -1,  393,   -1,  266,   -1,  268,   -1,  270,  335,  336,
  337,  338,  339,  340,  341,  342,  343,  344,  345,  346,
  347,  348,  349,  350,  351,  352,  353,  354,  355,  356,
  357,  358,  359,  360,  361,  362,  363,  364,  365,  366,
  367,  368,  369,  370,  371,  372,   -1,  374,  375,  376,
   -1,   -1,  379,   -1,   -1,  382,  383,   -1,   -1,   -1,
  387,  388,  389,  390,  391,   -1,  393,  394,  265,  266,
   -1,  268,  335,  270,  337,  402,  339,  340,  341,  342,
  343,  344,  345,  346,  347,  348,  349,  350,  351,  352,
  353,   -1,  355,  356,  357,  358,  359,  360,  361,  362,
  363,  364,  365,  366,  367,  368,  369,  370,  371,  372,
   -1,  374,  375,  376,   -1,   -1,  379,   -1,   -1,  382,
  383,   -1,   -1,   -1,  387,   -1,  389,  390,  391,   -1,
  393,   -1,   -1,   -1,   -1,  266,   -1,   -1,  335,  336,
  337,  338,  339,  340,  341,  342,  343,  344,  345,  346,
  347,  348,  349,  350,  351,  352,  353,  354,  355,  356,
  357,  358,  359,  360,  361,  362,  363,  364,  365,  366,
  367,  368,  369,  370,  371,  372,   -1,  374,  375,  376,
   -1,   -1,  379,   -1,   -1,  382,  383,   -1,   -1,   -1,
  387,  388,  389,  390,  391,   -1,  393,  394,  265,  266,
   -1,  268,   -1,  270,   -1,  402,  337,  338,  339,  340,
  341,  342,  343,  344,  345,  346,  347,  348,  349,  350,
  351,  352,  353,   -1,  355,  356,  357,  358,  359,  360,
  361,  362,  363,  364,  365,  366,  367,  368,  369,  370,
  371,  372,   -1,  374,  375,  376,   -1,   -1,  379,   -1,
   -1,  382,  383,   -1,   -1,   -1,  387,   -1,  389,  390,
  391,   -1,  393,   -1,   -1,  266,   -1,   -1,  335,  336,
  337,  338,  339,  340,  341,  342,  343,  344,  345,  346,
  347,  348,  349,  350,  351,  352,  353,  354,  355,  356,
  357,  358,  359,  360,  361,  362,  363,  364,  365,  366,
  367,  368,  369,  370,  371,  372,   -1,  374,  375,  376,
   -1,   -1,  379,   -1,   -1,  382,  383,   -1,   -1,   -1,
  387,  388,  389,  390,  391,   -1,  393,  394,  265,  266,
   -1,  268,   -1,  270,   -1,  402,  337,  338,  339,  340,
  341,  342,  343,  344,  345,  346,  347,  348,  349,  350,
  351,  352,  353,   -1,  355,  356,  357,  358,  359,  360,
  361,  362,  363,  364,  365,  366,  367,  368,  369,  370,
  371,  372,   -1,  374,  375,  376,   -1,  266,  379,   -1,
   -1,  382,  383,   -1,   -1,   -1,  387,   -1,  389,  390,
  391,   -1,  393,   -1,   -1,   -1,   -1,   -1,  335,  336,
  337,  338,  339,  340,  341,  342,  343,  344,  345,  346,
  347,  348,  349,  350,  351,  352,  353,  354,  355,  356,
  357,  358,  359,  360,  361,  362,  363,  364,  365,  366,
  367,  368,  369,  370,  371,  372,   -1,  374,  375,  376,
  265,  266,   -1,  268,   -1,  270,   -1,   -1,   -1,   -1,
   -1,  388,   -1,   -1,   -1,   -1,   -1,  394,   -1,   -1,
   -1,   -1,   -1,   -1,  353,  402,  355,  356,  357,  358,
  359,  360,  361,  362,  363,  364,  365,  366,  367,  368,
  369,  370,  371,  372,   -1,  374,  375,  376,  266,   -1,
  379,   -1,   -1,  382,  383,   -1,   -1,   -1,  387,   -1,
  389,  390,  391,   -1,  393,   -1,   -1,   -1,   -1,   -1,
  335,  336,  337,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
  365,  366,  367,  368,  369,  370,  371,  372,   -1,  374,
  375,  376,  265,  266,   -1,  268,   -1,  270,   -1,   -1,
   -1,   -1,   -1,  388,   -1,   -1,   -1,   -1,   -1,  394,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  402,  356,  357,
  358,  359,  360,  361,  362,  363,  364,  365,  366,  367,
  368,  369,  370,  371,  372,   -1,  374,  375,  376,  266,
   -1,  379,   -1,   -1,  382,  383,   -1,   -1,   -1,  387,
   -1,  389,  390,  391,   -1,  393,   -1,   -1,   -1,   -1,
   -1,   -1,  335,  336,  337,  338,  339,  340,  341,  342,
  343,  344,  345,  346,  347,  348,  349,  350,  351,  352,
  353,  354,  355,  356,  357,  358,  359,  360,  361,  362,
  363,  364,  365,  366,  367,  368,  369,  370,  371,  372,
   -1,  374,  375,  376,  265,  266,   -1,  268,   -1,  270,
   -1,   -1,   -1,   -1,   -1,  388,   -1,   -1,   -1,   -1,
   -1,  394,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  402,
  357,  358,  359,  360,  361,  362,  363,  364,  365,  366,
  367,  368,  369,  370,  371,  372,   -1,  374,  375,  376,
  266,   -1,  379,   -1,   -1,  382,  383,   -1,   -1,   -1,
  387,   -1,  389,  390,  391,   -1,  393,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  335,  336,  337,  338,  339,  340,
  341,  342,  343,  344,  345,  346,  347,  348,  349,  350,
  351,  352,  353,  354,  355,  356,  357,  358,  359,  360,
  361,  362,  363,  364,  365,  366,  367,  368,  369,  370,
  371,  372,   -1,  374,  375,  376,  265,  266,   -1,  268,
   -1,  270,   -1,   -1,   -1,   -1,   -1,  388,   -1,   -1,
   -1,   -1,   -1,  394,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  402,  358,  359,  360,  361,  362,  363,  364,  365,
  366,  367,  368,  369,  370,  371,  372,   -1,  374,  375,
  376,  266,   -1,  379,   -1,   -1,  382,  383,   -1,   -1,
   -1,  387,   -1,  389,  390,  391,   -1,  393,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  335,  336,  337,  338,
  339,  340,  341,  342,  343,  344,  345,  346,  347,  348,
  349,  350,  351,  352,  353,  354,  355,  356,  357,  358,
  359,  360,  361,  362,  363,  364,  365,  366,  367,  368,
  369,  370,  371,  372,   -1,  374,  375,  376,  265,  266,
   -1,  268,   -1,  270,   -1,   -1,   -1,   -1,   -1,  388,
   -1,   -1,   -1,   -1,   -1,  394,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  402,  359,  360,  361,  362,  363,  364,
  365,  366,  367,  368,  369,  370,  371,  372,   -1,  374,
  375,  376,   -1,   -1,  379,   -1,   -1,  382,  383,   -1,
   -1,   -1,  387,   -1,  389,  390,  391,   -1,  393,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  335,  336,
  337,  338,  339,  340,  341,  342,  343,  344,  345,  346,
  347,  348,  349,  350,  351,  352,  353,  354,  355,  356,
  357,  358,  359,  360,  361,  362,  363,  364,  365,  366,
  367,  368,  369,  370,  371,  372,   -1,  374,  375,  376,
  265,  266,   -1,  268,   -1,  270,   -1,   -1,   -1,   -1,
   -1,  388,   -1,   -1,   -1,   -1,   -1,  394,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  402,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  335,  336,  337,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
  365,  366,  367,  368,  369,  370,  371,  372,   -1,  374,
  375,  376,  265,  266,   -1,  268,   -1,  270,   -1,   -1,
   -1,   -1,   -1,  388,   -1,   -1,   -1,   -1,   -1,  394,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  402,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  335,  336,  337,  338,  339,  340,  341,  342,
  343,  344,  345,  346,  347,  348,  349,  350,  351,  352,
  353,  354,  355,  356,  357,  358,  359,  360,  361,  362,
  363,  364,  365,  366,  367,  368,  369,  370,  371,  372,
   -1,  374,  375,  376,  265,  266,   -1,  268,   -1,  270,
   -1,   -1,   -1,   -1,   -1,  388,   -1,   -1,   -1,   -1,
   -1,  394,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  402,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  335,  336,  337,  338,  339,  340,
  341,  342,  343,  344,  345,  346,  347,  348,  349,  350,
  351,  352,  353,  354,  355,  356,  357,  358,  359,  360,
  361,  362,  363,  364,  365,  366,  367,  368,  369,  370,
  371,  372,   -1,  374,  375,  376,  265,  266,   -1,  268,
   -1,  270,   -1,   -1,   -1,   -1,   -1,  388,   -1,   -1,
   -1,   -1,   -1,  394,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  402,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  335,  336,  337,  338,
  339,  340,  341,  342,  343,  344,  345,  346,  347,  348,
  349,  350,  351,  352,  353,  354,  355,  356,  357,  358,
  359,  360,  361,  362,  363,  364,  365,  366,  367,  368,
  369,  370,  371,  372,   -1,  374,  375,  376,  265,  266,
   -1,  268,   -1,  270,   -1,   -1,   -1,   -1,   -1,  388,
   -1,   -1,   -1,   -1,   -1,  394,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  402,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  335,  336,
  337,  338,  339,  340,  341,  342,  343,  344,  345,  346,
  347,  348,  349,  350,  351,  352,  353,  354,  355,  356,
  357,  358,  359,  360,  361,  362,  363,  364,  365,  366,
  367,  368,  369,  370,  371,  372,  265,  266,   -1,  268,
   -1,  270,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  388,   -1,   -1,   -1,   -1,   -1,  394,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  402,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  335,  336,  337,  338,
  339,  340,  341,  342,  343,  344,  345,  346,  347,  348,
  349,  350,  351,  352,  353,  354,  355,  356,  357,  358,
  359,  360,  361,  362,  363,  364,  365,  366,  367,  368,
  369,  370,  371,  372,  265,  266,   -1,  268,   -1,  270,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  388,
   -1,   -1,   -1,   -1,   -1,  394,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  402,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  335,  336,  337,  338,  339,  340,
  341,  342,  343,  344,  345,  346,  347,  348,  349,  350,
  351,  352,  353,  354,  355,  356,  357,  358,  359,  360,
  361,  362,  363,  364,  365,  366,  367,  368,  369,  370,
  371,  372,  265,  266,   -1,  268,   -1,  270,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  388,   -1,   -1,
   -1,   -1,   -1,  394,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  402,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  335,  336,  337,  338,  339,  340,  341,  342,
  343,  344,  345,  346,  347,  348,  349,  350,  351,  352,
  353,  354,  355,  356,  357,  358,  359,  360,  361,  362,
  363,  364,  365,  366,  367,  368,  369,  370,  371,  372,
  265,  266,   -1,  268,   -1,  270,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  388,   -1,   -1,   -1,   -1,
   -1,  394,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  402,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  335,  336,  337,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
  365,  366,  367,  368,  369,  370,  371,  372,  265,   -1,
   -1,  268,   -1,  270,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  388,   -1,   -1,   -1,   -1,   -1,  394,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  402,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  335,  336,
  337,  338,  339,  340,  341,  342,  343,  344,  345,  346,
  347,  348,  349,  350,  351,  352,  353,  354,  355,  356,
  357,  358,  359,  360,  361,  362,  363,  364,  365,  366,
  367,  368,  369,  265,   -1,   -1,  268,   -1,  270,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  388,   -1,   -1,   -1,   -1,   -1,  394,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  402,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  335,  336,  337,  338,  339,  340,  341,
  342,  343,  344,  345,  346,  347,  348,  349,  350,  351,
  352,  353,  354,  355,  356,  357,  358,  359,  360,  361,
  362,  363,  364,  365,  366,  367,  368,  369,  265,   -1,
   -1,  268,   -1,  270,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  260,  261,  262,   -1,  388,   -1,   -1,   -1,
   -1,   -1,  394,   -1,   -1,   -1,   -1,   -1,  276,  277,
  402,  279,  280,  281,  282,  283,  284,  285,  286,  287,
  288,  289,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  314,  315,  335,  336,
  337,  338,  339,  340,  341,  342,  343,  344,  345,  346,
  347,  348,  349,  350,  351,  352,  353,  354,  355,  356,
  357,  358,  359,  360,  361,  362,  363,  364,  365,  366,
  367,  265,   -1,   -1,  268,   -1,  270,   -1,  356,   -1,
   -1,  359,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  388,  370,   -1,   -1,   -1,  374,  394,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  402,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  393,  394,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  335,  336,  337,  338,  339,  340,  341,  342,  343,
  344,  345,  346,  347,  348,  349,  350,  351,  352,  353,
  354,  355,  356,  357,  358,  359,  360,  361,  362,  363,
  364,  365,  366,  367,  265,   -1,   -1,  268,   -1,  270,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  388,   -1,   -1,   -1,   -1,   -1,
  394,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  402,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  335,  336,  337,  338,  339,  340,
  341,  342,  343,  344,  345,  346,  347,  348,  349,  350,
  351,  352,  353,  354,  355,  356,  357,  358,  359,  360,
  361,  362,  363,  364,  365,  265,   -1,   -1,  268,   -1,
  270,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  388,   -1,   -1,
   -1,   -1,   -1,  394,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  402,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  335,  336,  337,  338,  339,
  340,  341,  342,  343,  344,  345,  346,  347,  348,  349,
  350,  351,  352,  353,  354,  355,  356,  357,  358,  359,
  360,  361,  362,  363,  364,  365,  265,   -1,   -1,  268,
   -1,  270,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  388,   -1,
   -1,   -1,   -1,   -1,  394,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  402,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  335,  336,  337,  338,
  339,  340,  341,  342,  343,  344,  345,  346,  347,  348,
  349,  350,  351,  352,  353,  354,  355,  356,  357,  358,
  359,  360,  361,  362,  363,  364,  365,  265,   -1,   -1,
  268,   -1,  270,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  388,
   -1,   -1,   -1,   -1,   -1,  394,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  402,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  335,  336,  337,
  338,  339,  340,  341,  342,  343,  344,  345,  346,  347,
  348,  349,  350,  351,  352,  353,  354,  355,  356,  357,
  358,  359,  360,  361,  362,  363,  364,  365,  265,   -1,
   -1,  268,   -1,  270,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  388,   -1,   -1,   -1,   -1,   -1,  394,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  402,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  335,  336,
  337,  338,  339,  340,  341,  342,  343,  344,  345,  346,
  347,  348,  349,  350,  351,  352,  353,  354,  355,  356,
  357,  358,  359,  360,  361,  265,   -1,   -1,  268,   -1,
  270,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  388,   -1,  265,   -1,   -1,  268,  394,  270,   -1,
   -1,   -1,   -1,   -1,   -1,  402,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  335,  336,  337,  338,  339,
  340,  341,  342,  343,  344,  345,  346,  347,  348,  349,
  350,  351,  352,  353,  354,  355,  356,  357,  358,  359,
  360,  361,   -1,  335,  336,  337,  338,  339,  340,  341,
  342,  343,  344,  345,  346,  347,  348,  349,  350,  351,
  352,  353,  354,  355,  356,  357,  358,  359,  388,   -1,
  265,   -1,   -1,  268,  394,  270,   -1,   -1,   -1,   -1,
   -1,   -1,  402,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  265,   -1,  388,  268,   -1,  270,
   -1,   -1,  394,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  402,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  335,  336,  337,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,  356,  357,  358,  335,  336,  337,  338,  339,  340,
  341,  342,  343,  344,  345,  346,  347,  348,  349,  350,
  351,  352,  353,  354,  355,  356,  357,  265,   -1,   -1,
  268,   -1,  270,  388,   -1,   -1,   -1,   -1,   -1,  394,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  402,   -1,  265,
   -1,   -1,  268,   -1,  270,   -1,   -1,  388,   -1,   -1,
   -1,   -1,   -1,  394,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  402,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  335,  336,  337,
  338,  339,  340,  341,  342,  343,  344,  345,  346,  347,
  348,  349,  350,  351,  352,  353,  354,  355,  356,  335,
  336,  337,  338,  339,  340,  341,  342,  343,  344,  345,
  346,  347,  348,  349,  350,  351,  352,  353,  354,  355,
  265,   -1,   -1,  268,   -1,  270,   -1,   -1,   -1,   -1,
  388,   -1,   -1,   -1,   -1,   -1,  394,   -1,   -1,   -1,
  265,   -1,   -1,  268,  402,  270,   -1,   -1,   -1,   -1,
   -1,   -1,  388,   -1,   -1,   -1,   -1,   -1,  394,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  402,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  335,  336,  337,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,   -1,  354,
  335,  336,  337,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,   -1,  354,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  388,   -1,   -1,   -1,   -1,   -1,  394,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  402,   -1,  260,
  261,  262,   -1,  388,   -1,  266,  267,   -1,  269,  394,
   -1,  272,  273,  274,  275,  276,  277,  402,  279,  280,
  281,  282,  283,  284,  285,  286,  287,  288,  289,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  299,  300,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  309,   -1,
   -1,   -1,  313,  314,  315,   -1,   -1,  318,  319,  320,
  321,  322,  323,  324,  325,  326,  327,  328,  329,   -1,
   -1,   -1,  333,  334,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  356,   -1,   -1,  359,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  369,  370,
   -1,   -1,   -1,  374,   -1,   -1,   -1,   -1,  379,   -1,
  381,  382,  383,   -1,   -1,   -1,  387,   -1,  389,  260,
  261,  262,  393,   -1,   -1,  266,   -1,   -1,  269,   -1,
   -1,  272,  273,  274,  275,  276,  277,   -1,  279,  280,
  281,  282,  283,  284,  285,  286,  287,  288,  289,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  299,  300,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  309,   -1,
   -1,   -1,  313,  314,  315,   -1,   -1,  318,  319,  320,
  321,  322,  323,  324,  325,  326,  327,  328,  329,   -1,
   -1,   -1,  333,  334,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  356,   -1,   -1,  359,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  369,  370,
   -1,   -1,   -1,  374,   -1,   -1,   -1,   -1,  379,   -1,
  381,  382,  383,   -1,   -1,   -1,  387,   -1,  389,  260,
  261,  262,  393,   -1,   -1,  266,  267,  268,  269,   -1,
   -1,   -1,   -1,   -1,   -1,  276,  277,   -1,  279,  280,
  281,  282,  283,  284,  285,  286,  287,  288,  289,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  309,   -1,
   -1,   -1,  313,  314,  315,   -1,   -1,  318,  319,  320,
  321,  322,  323,  324,  325,  326,  327,  328,  329,   -1,
   -1,   -1,  333,  334,  335,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  356,   -1,   -1,  359,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  369,  370,
   -1,   -1,   -1,  374,   -1,   -1,   -1,   -1,  379,   -1,
  381,  382,  383,   -1,   -1,   -1,  387,   -1,  389,  260,
  261,  262,  393,   -1,   -1,  266,   -1,  268,  269,   -1,
   -1,   -1,   -1,   -1,   -1,  276,  277,   -1,  279,  280,
  281,  282,  283,  284,  285,  286,  287,  288,  289,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  309,   -1,
   -1,   -1,  313,  314,  315,   -1,   -1,  318,  319,  320,
  321,  322,  323,  324,  325,  326,  327,  328,  329,   -1,
   -1,   -1,  333,  334,  335,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  356,   -1,   -1,  359,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  369,  370,
   -1,   -1,   -1,  374,   -1,   -1,   -1,   -1,  379,   -1,
  381,  382,  383,   -1,   -1,   -1,  387,   -1,  389,  260,
  261,  262,  393,   -1,   -1,  266,  267,  268,  269,   -1,
   -1,   -1,   -1,   -1,   -1,  276,  277,   -1,  279,  280,
  281,  282,  283,  284,  285,  286,  287,  288,  289,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  309,   -1,
   -1,   -1,  313,  314,  315,   -1,   -1,  318,  319,  320,
  321,  322,  323,  324,  325,  326,  327,  328,  329,   -1,
   -1,   -1,  333,  334,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  356,   -1,   -1,  359,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  369,  370,
   -1,   -1,   -1,  374,   -1,   -1,   -1,   -1,  379,   -1,
  381,  382,  383,   -1,   -1,   -1,  387,   -1,  389,  260,
  261,  262,  393,   -1,   -1,  266,   -1,   -1,  269,   -1,
   -1,   -1,   -1,   -1,   -1,  276,  277,   -1,  279,  280,
  281,  282,  283,  284,  285,  286,  287,  288,  289,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  309,   -1,
   -1,   -1,  313,  314,  315,   -1,   -1,  318,  319,  320,
  321,  322,  323,  324,  325,  326,  327,  328,  329,   -1,
   -1,   -1,  333,  334,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  356,   -1,   -1,  359,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  369,  370,
   -1,   -1,   -1,  374,   -1,   -1,   -1,   -1,  379,   -1,
  381,  382,  383,   -1,   -1,   -1,  387,  388,  389,  260,
  261,  262,  393,   -1,   -1,  266,   -1,   -1,  269,  270,
   -1,   -1,   -1,   -1,   -1,  276,  277,   -1,  279,  280,
  281,  282,  283,  284,  285,  286,  287,  288,  289,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  309,   -1,
   -1,   -1,  313,  314,  315,   -1,   -1,  318,  319,  320,
  321,  322,  323,  324,  325,  326,  327,  328,  329,   -1,
   -1,   -1,  333,  334,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  356,   -1,   -1,  359,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  369,  370,
   -1,   -1,   -1,  374,   -1,   -1,   -1,   -1,  379,   -1,
  381,  382,  383,   -1,   -1,   -1,  387,   -1,  389,  260,
  261,  262,  393,   -1,   -1,  266,  267,   -1,  269,   -1,
   -1,   -1,   -1,   -1,   -1,  276,  277,   -1,  279,  280,
  281,  282,  283,  284,  285,  286,  287,  288,  289,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  309,   -1,
   -1,   -1,  313,  314,  315,   -1,   -1,  318,  319,  320,
  321,  322,  323,  324,  325,  326,  327,  328,  329,   -1,
   -1,   -1,  333,  334,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  356,   -1,   -1,  359,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  369,  370,
   -1,   -1,   -1,  374,   -1,   -1,   -1,   -1,  379,   -1,
  381,  382,  383,   -1,   -1,   -1,  387,   -1,  389,  260,
  261,  262,  393,   -1,   -1,  266,   -1,   -1,  269,   -1,
   -1,   -1,   -1,   -1,   -1,  276,  277,   -1,  279,  280,
  281,  282,  283,  284,  285,  286,  287,  288,  289,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  309,   -1,
   -1,   -1,  313,  314,  315,   -1,   -1,  318,  319,  320,
  321,  322,  323,  324,  325,  326,  327,  328,  329,   -1,
   -1,   -1,  333,  334,  335,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  356,   -1,   -1,  359,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  369,  370,
   -1,   -1,   -1,  374,   -1,   -1,   -1,   -1,  379,   -1,
  381,  382,  383,   -1,   -1,   -1,  387,   -1,  389,  260,
  261,  262,  393,   -1,   -1,  266,  267,   -1,  269,   -1,
   -1,   -1,   -1,   -1,   -1,  276,  277,   -1,  279,  280,
  281,  282,  283,  284,  285,  286,  287,  288,  289,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  309,   -1,
   -1,   -1,  313,  314,  315,   -1,   -1,  318,  319,  320,
  321,  322,  323,  324,  325,  326,  327,  328,  329,   -1,
   -1,   -1,  333,  334,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  356,   -1,   -1,  359,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  369,  370,
   -1,   -1,   -1,  374,   -1,   -1,   -1,   -1,  379,   -1,
  381,  382,  383,   -1,   -1,   -1,  387,   -1,  389,  260,
  261,  262,  393,   -1,   -1,  266,   -1,   -1,  269,   -1,
   -1,   -1,   -1,   -1,   -1,  276,  277,   -1,  279,  280,
  281,  282,  283,  284,  285,  286,  287,  288,  289,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  309,   -1,
   -1,   -1,  313,  314,  315,   -1,   -1,  318,  319,  320,
  321,  322,  323,  324,  325,  326,  327,  328,  329,   -1,
   -1,   -1,  333,  334,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  356,   -1,   -1,  359,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  369,  370,
   -1,   -1,   -1,  374,  260,  261,  262,   -1,  379,   -1,
  381,  382,  383,   -1,   -1,   -1,  387,   -1,  389,   -1,
  276,  277,  393,  279,  280,  281,  282,  283,  284,  285,
  286,  287,  288,  289,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  260,  261,  262,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  313,  314,  315,
  276,  277,   -1,  279,  280,  281,  282,  283,  284,  285,
  286,  287,  288,  289,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  314,  315,
  356,   -1,   -1,  359,   -1,   -1,   -1,  266,   -1,  268,
   -1,  270,   -1,   -1,  370,   -1,   -1,   -1,  374,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  393,   -1,   -1,
  356,   -1,   -1,  359,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  370,   -1,   -1,   -1,  374,   -1,
   -1,   -1,   -1,   -1,  266,   -1,   -1,   -1,  270,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  335,  393,  337,  338,
  339,  340,  341,  342,  343,  344,  345,  346,  347,  348,
  349,  350,  351,  352,  353,   -1,  355,  356,  357,  358,
  359,  360,  361,  362,  363,  364,  365,  366,  367,  368,
  369,  370,  371,  372,   -1,  374,  375,  376,   -1,   -1,
  379,  266,   -1,  382,  383,   -1,   -1,   -1,  387,   -1,
  389,  390,  391,   -1,  393,  337,  338,  339,  340,  341,
  342,  343,  344,  345,  346,  347,  348,  349,  350,  351,
  352,  353,   -1,  355,  356,  357,  358,  359,  360,  361,
  362,  363,  364,  365,  366,  367,  368,  369,  370,  371,
  372,   -1,  374,  375,  376,   -1,   -1,  379,  266,   -1,
  382,  383,   -1,   -1,   -1,  387,   -1,  389,  390,  391,
   -1,  393,   -1,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
  365,  366,  367,  368,  369,  370,  371,  372,   -1,  374,
  375,  376,   -1,   -1,  379,  266,   -1,  382,  383,   -1,
   -1,   -1,  387,   -1,  389,  390,  391,  335,  393,   -1,
  338,  339,  340,  341,  342,  343,  344,  345,  346,  347,
  348,  349,  350,  351,  352,  353,   -1,  355,  356,  357,
  358,  359,  360,  361,  362,  363,  364,  365,  366,  367,
  368,  369,  370,  371,  372,   -1,  374,  375,  376,   -1,
   -1,  379,  266,   -1,  382,  383,   -1,   -1,   -1,  387,
   -1,  389,  390,  391,   -1,  393,  337,  338,  339,  340,
  341,  342,  343,  344,  345,  346,  347,  348,  349,  350,
  351,  352,  353,   -1,  355,  356,  357,  358,  359,  360,
  361,  362,  363,  364,  365,  366,  367,  368,  369,  370,
  371,  372,   -1,  374,  375,  376,   -1,   -1,  379,   -1,
   -1,  382,  383,   -1,   -1,   -1,  387,   -1,  389,  390,
  391,   -1,  393,   -1,  338,  339,  340,  341,  342,  343,
  344,  345,  346,  347,  348,  349,  350,  351,  352,  353,
   -1,  355,  356,  357,  358,  359,  360,  361,  362,  363,
  364,  365,  366,  367,  368,  369,  370,  371,  372,   -1,
  374,  375,  376,   -1,   -1,  379,   -1,   -1,  382,  383,
   -1,   -1,   -1,  387,   -1,  389,  390,  391,   -1,  393,
};
#define YYFINAL 1
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 402
#if YYDEBUG
static const char *yyname[] = {

"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"VAR","EXPR","ARRAY","STRUCT",
"UNION","ENUM","COMP","HASH","SEMI","MOD","OC","CC","DOLLAR","DOTDOTDOT",
"ENDFILE","GLOBAL","AUTO","STATIC","CONST","POLY","INTEGER","NATURAL",
"RATIONAL","REAL","STRING","FOREIGN","FILET","MUTEX","SEMAPHORE","CONTINUATION",
"THREAD","VOID","BOOL","FUNCTION","FUNC","EXCEPTION","RAISE","TYPEDEF","IMPORT",
"NEW","ANONINIT","NAMESPACE","PUBLIC","PROTECTED","EXTEND","WHILE","DO","FOR",
"SWITCH","BREAK","CONTINUE","RETURNTOK","FORK","CASE","DEFAULT","TWIXT","NAME",
"TYPENAME","NAMESPACENAME","COMMAND","NAMECOMMAND","TEN_NUM","OCTAL0_NUM",
"OCTAL_NUM","BINARY_NUM","HEX_NUM","TEN_FLOAT","OCTAL0_FLOAT","OCTAL_FLOAT",
"BINARY_FLOAT","HEX_FLOAT","CHAR_CONST","STRING_CONST","POLY_CONST",
"THREAD_CONST","COMMENT_CONST","VOIDVAL","BOOLVAL","DARROW","POUND","COMMA",
"ASSIGN","ASSIGNPLUS","ASSIGNMINUS","ASSIGNTIMES","ASSIGNDIVIDE","ASSIGNDIV",
"ASSIGNMOD","ASSIGNPOW","ASSIGNSHIFTL","ASSIGNSHIFTR","ASSIGNLXOR","ASSIGNLAND",
"ASSIGNLOR","ASSIGNOR","ASSIGNAND","QUEST","COLON","OR","AND","LOR","LXOR",
"LAND","EQ","NE","LT","GT","LE","GE","SHIFTL","SHIFTR","PLUS","MINUS","TIMES",
"DIVIDE","DIV","POW","STARSTAR","POW2","POW3","UNIONCAST","UMINUS","BANG",
"FACT","LNOT","INC","DEC","STAR","AMPER","THREADID","OS","CS","DOT","ARROW",
"STAROS","CALL","OP","CP","POINTER","COLONCOLON","IF","TRY","NONL","ELSE",
"CATCH","NL",
};
static const char *yyrule[] = {
"$accept : lines",
"lines : lines pcommand",
"lines :",
"pcommand : command",
"pcommand : error reset eend",
"eend : NL",
"eend : SEMI",
"eend : ENDFILE",
"ignorenl :",
"attendnl :",
"reset :",
"not_command :",
"opt_nl : NL",
"opt_nl :",
"opt_semi : SEMI",
"opt_semi :",
"opt_comma : COMMA",
"opt_comma :",
"command : not_command expr reset NL",
"command : not_command expr POUND expr reset NL",
"command : not_command statement reset opt_nl",
"command : not_command COMMAND opt_exprs reset opt_semi NL",
"command : not_command NAMECOMMAND opt_rawnames reset opt_semi NL",
"command : NL",
"command : ENDFILE",
"opt_rawnames : rawnames",
"opt_rawnames :",
"rawnames : rawname COMMA rawnames",
"rawnames : rawname",
"rawname : rawnamespace rawatom",
"rawatom : NAME",
"rawatom : NAMESPACENAME",
"rawatom : TYPENAME",
"rawnamespace : rawnamespace rawatom COLONCOLON",
"rawnamespace :",
"fulltype : namespace TYPENAME",
"fulltype : TYPENAME",
"fullname : namespace namespacename",
"fullname : namespacename",
"fullnames : fullname",
"fullnames : fullname COMMA fullnames",
"namespace : namespace NAMESPACENAME COLONCOLON",
"namespace : NAMESPACENAME COLONCOLON",
"namespacename : NAME",
"namespacename : NAMESPACENAME",
"namespace_start :",
"namespace_end :",
"block : block_start statements block_end",
"block_start : OC namespace_start",
"block_end : namespace_end CC",
"statements : statement statements",
"statements :",
"if_statement : IF ignorenl namespace_start OP expr CP statement",
"if_statement : IF ignorenl namespace_start OP expr CP statement ELSE statement",
"statement : simple_statement",
"statement : block",
"simple_statement : if_statement namespace_end attendnl",
"simple_statement : WHILE ignorenl namespace_start OP expr CP statement namespace_end attendnl",
"simple_statement : DO ignorenl namespace_start statement WHILE OP expr CP namespace_end attendnl",
"simple_statement : FOR ignorenl namespace_start OP for_exprs CP statement namespace_end attendnl",
"simple_statement : SWITCH ignorenl namespace_start OP expr CP case_block namespace_end attendnl",
"simple_statement : union_or_enum SWITCH ignorenl namespace_start OP expr CP union_case_block namespace_end attendnl",
"simple_statement : BREAK SEMI",
"simple_statement : CONTINUE SEMI",
"simple_statement : RETURNTOK opt_expr SEMI",
"simple_statement : expr SEMI",
"simple_statement : SEMI",
"simple_statement : func_decl doc_string opt_func_body namespace_end",
"simple_statement : opt_publish EXCEPTION ignorenl NAME namespace_start opt_argdecls namespace_end doc_string SEMI attendnl",
"simple_statement : RAISE fullname OP opt_exprs CP SEMI",
"simple_statement : opt_publish TYPEDEF ignorenl typenames SEMI attendnl",
"simple_statement : opt_publish TYPEDEF ignorenl type typenames SEMI attendnl",
"$$1 :",
"simple_statement : publish_extend NAMESPACE ignorenl namespacename $$1 OC statements CC attendnl",
"simple_statement : opt_publish IMPORT ignorenl fullnames SEMI attendnl",
"simple_statement : try_statement attendnl",
"simple_statement : TWIXT ignorenl namespace_start OP opt_expr SEMI opt_expr CP statement namespace_end attendnl",
"for_exprs : opt_expr SEMI for_exprs",
"for_exprs : opt_expr",
"try_body_statement : simple_statement",
"try_body_statement : OC statements CC",
"try_statement : TRY ignorenl try_body_statement catches",
"catches : catches catch",
"catches :",
"catch : CATCH fullname namespace_start args doc_string block namespace_end",
"opt_func_body : func_body",
"opt_func_body : SEMI",
"$$2 :",
"func_body : $$2 block_or_expr",
"block_or_expr : block",
"block_or_expr : attendnl ASSIGN simpleexpr SEMI",
"union_or_enum : UNION",
"union_or_enum : ENUM",
"see_comment :",
"doc_string : see_comment opt_comment",
"opt_comment : COMMENT_CONST",
"opt_comment :",
"case_block : block_start cases block_end",
"cases : case cases",
"cases :",
"case : CASE expr COLON statements",
"case : DEFAULT COLON statements",
"union_case_block : block_start union_cases block_end",
"union_cases : union_case union_cases",
"union_cases :",
"union_case : CASE namespace_start NAME opt_name COLON statements namespace_end",
"union_case : DEFAULT COLON statements",
"opt_name : NAME",
"opt_name :",
"atoms : NAME COMMA atoms",
"atoms : NAME",
"typenames : typename COMMA typenames",
"typenames : typename",
"typename : TYPENAME",
"typename : NAME",
"initnames : name opt_init next_decl initnames",
"initnames : name opt_init",
"name : NAME",
"next_decl : COMMA",
"func_decl : func_name namespace_start opt_argdefines CP",
"func_name : decl NAME OP",
"func_name : decl FUNCTION NAME OP",
"func_name : FUNCTION ignorenl NAME OP",
"opt_init : ASSIGN simpleexpr",
"opt_init : ASSIGN init",
"opt_init :",
"decl : publish opt_class opt_type opt_nl",
"decl : class opt_type opt_nl",
"decl : type opt_nl",
"subscripts : opt_argdecls subscripts",
"subscripts : OS opt_stars CS subscripts",
"subscripts : OS dotdotdots CS subscripts",
"subscripts : OS dims CS subscripts",
"subscripts : OS type CS subscripts",
"subscripts :",
"type : subtype subscripts",
"type : TIMES type",
"type : STARSTAR type",
"type : AND type",
"type : LAND type",
"type : type PLUS type",
"subtype : basetype",
"subtype : STRUCT OC struct_members CC",
"subtype : UNION OC union_members CC",
"subtype : ENUM OC atoms CC",
"subtype : OP type CP",
"subtype : fulltype",
"opt_type : type",
"opt_type :",
"basetype : POLY",
"basetype : INTEGER",
"basetype : RATIONAL",
"basetype : REAL",
"basetype : STRING",
"basetype : FILET",
"basetype : MUTEX",
"basetype : SEMAPHORE",
"basetype : CONTINUATION",
"basetype : THREAD",
"basetype : VOID",
"basetype : BOOL",
"basetype : FOREIGN",
"opt_stars : stars",
"opt_stars :",
"stars : stars COMMA TIMES",
"stars : TIMES",
"dotdotdots : dotdotdots COMMA DOTDOTDOT",
"dotdotdots : DOTDOTDOT",
"dims : simpleexpr COMMA dims",
"dims : simpleexpr",
"struct_members : opt_type atoms SEMI struct_members",
"struct_members :",
"union_members : opt_type atoms SEMI union_members",
"union_members :",
"opt_class : class",
"opt_class :",
"class : GLOBAL",
"class : AUTO",
"class : STATIC",
"class : CONST",
"opt_publish : publish",
"opt_publish :",
"publish : PUBLIC",
"publish : PROTECTED",
"publish_extend : opt_publish",
"publish_extend : EXTEND",
"opt_argdecls : OP argdecls CP",
"opt_argdecls : OP CP",
"argdecls : argdecl COMMA argdecls",
"argdecls : argdecl opt_dotdotdot",
"argdecl : type NAME",
"argdecl : type",
"args : OP opt_argdefines CP",
"opt_argdefines : ignorenl argdefines",
"opt_argdefines : ignorenl",
"argdefines : argdefine COMMA argdefines",
"argdefines : argdefine opt_dotdotdot",
"argdefine : opt_type NAME",
"argdefine : type",
"opt_dotdotdot : DOTDOTDOT",
"opt_dotdotdot :",
"opt_expr : expr",
"opt_expr :",
"expr : comma_expr",
"expr : decl initnames",
"comma_expr : simpleexpr",
"comma_expr : comma_expr COMMA simpleexpr",
"opt_exprs : exprs",
"opt_exprs :",
"exprs : simpleexpr COMMA exprs",
"exprs : simpleexpr",
"opt_actuals : actuals",
"opt_actuals :",
"actuals : simpleexpr COMMA actuals",
"actuals : simpleexpr opt_dotdotdot",
"func_right : attendnl ASSIGN simpleexpr",
"$$3 :",
"func_right : $$3 block",
"simpleexpr : simpleexpr assignop simpleexpr",
"simpleexpr : opt_type FUNC namespace_start args doc_string func_right namespace_end",
"simpleexpr : MOD integer",
"simpleexpr : TIMES simpleexpr",
"simpleexpr : STARSTAR simpleexpr",
"simpleexpr : LAND simpleexpr",
"simpleexpr : AND simpleexpr",
"simpleexpr : MINUS simpleexpr",
"simpleexpr : LNOT simpleexpr",
"simpleexpr : BANG simpleexpr",
"simpleexpr : simpleexpr BANG",
"simpleexpr : INC simpleexpr",
"simpleexpr : simpleexpr INC",
"simpleexpr : DEC simpleexpr",
"simpleexpr : simpleexpr DEC",
"simpleexpr : FORK simpleexpr",
"simpleexpr : simpleexpr PLUS simpleexpr",
"simpleexpr : simpleexpr MINUS simpleexpr",
"simpleexpr : simpleexpr TIMES simpleexpr",
"simpleexpr : simpleexpr DIVIDE simpleexpr",
"simpleexpr : simpleexpr DIV simpleexpr",
"simpleexpr : simpleexpr MOD simpleexpr",
"simpleexpr : simpleexpr STARSTAR simpleexpr",
"simpleexpr : simpleexpr POW2",
"simpleexpr : simpleexpr POW3",
"simpleexpr : simpleexpr SHIFTL simpleexpr",
"simpleexpr : simpleexpr SHIFTR simpleexpr",
"simpleexpr : simpleexpr QUEST simpleexpr COLON simpleexpr",
"simpleexpr : simpleexpr LXOR simpleexpr",
"simpleexpr : simpleexpr LAND simpleexpr",
"simpleexpr : simpleexpr LOR simpleexpr",
"simpleexpr : simpleexpr AND simpleexpr",
"simpleexpr : simpleexpr OR simpleexpr",
"simpleexpr : simpleexpr EQ simpleexpr",
"simpleexpr : simpleexpr NE simpleexpr",
"simpleexpr : simpleexpr LT simpleexpr",
"simpleexpr : simpleexpr GT simpleexpr",
"simpleexpr : simpleexpr LE simpleexpr",
"simpleexpr : simpleexpr GE simpleexpr",
"simpleexpr : fullname",
"simpleexpr : TEN_NUM",
"simpleexpr : OCTAL_NUM",
"simpleexpr : OCTAL0_NUM",
"simpleexpr : BINARY_NUM",
"simpleexpr : HEX_NUM",
"simpleexpr : TEN_FLOAT",
"simpleexpr : OCTAL_FLOAT",
"simpleexpr : OCTAL0_FLOAT",
"simpleexpr : BINARY_FLOAT",
"simpleexpr : HEX_FLOAT",
"simpleexpr : CHAR_CONST",
"simpleexpr : STRING_CONST",
"simpleexpr : VOIDVAL",
"simpleexpr : BOOLVAL",
"simpleexpr : OS CS",
"simpleexpr : OP type CP namespace_start init namespace_end",
"simpleexpr : OP OS stars CS CP namespace_start arrayinit namespace_end",
"simpleexpr : OP OS dims CS CP namespace_start opt_arrayinit namespace_end",
"simpleexpr : OP OS type CS CP namespace_start opt_hashinit namespace_end",
"simpleexpr : type DOT NAME",
"simpleexpr : OP type DOT NAME CP simpleexpr",
"simpleexpr : DOLLAR opt_integer",
"simpleexpr : DOT",
"simpleexpr : OP expr CP",
"simpleexpr : OP block CP",
"simpleexpr : simpleexpr STAROS dims CS",
"simpleexpr : simpleexpr OS dims CS",
"simpleexpr : simpleexpr OP opt_actuals CP",
"simpleexpr : simpleexpr DOT NAME",
"simpleexpr : simpleexpr ARROW NAME",
"opt_integer : integer",
"opt_integer :",
"assignop : ASSIGNPLUS",
"assignop : ASSIGNMINUS",
"assignop : ASSIGNTIMES",
"assignop : ASSIGNDIVIDE",
"assignop : ASSIGNDIV",
"assignop : ASSIGNMOD",
"assignop : ASSIGNPOW",
"assignop : ASSIGNSHIFTL",
"assignop : ASSIGNSHIFTR",
"assignop : ASSIGNLXOR",
"assignop : ASSIGNLAND",
"assignop : ASSIGNLOR",
"assignop : ASSIGNOR",
"assignop : ASSIGNAND",
"assignop : ASSIGN",
"integer : TEN_NUM",
"integer : OCTAL_NUM",
"integer : OCTAL0_NUM",
"integer : BINARY_NUM",
"integer : HEX_NUM",
"opt_arrayinit : arrayinit",
"opt_arrayinit : OC CC",
"opt_arrayinit :",
"arrayinit : OC arrayelts opt_comma opt_dotdotdot CC",
"arrayinit : OC OS namespace_start compnames comparray CS comprehension namespace_end CC",
"comprehension : ASSIGN arrayelt",
"comprehension : block",
"compnames : compname COMMA compnames",
"compnames : compname",
"compname : NAME",
"comparray :",
"arrayelts : arrayelts COMMA arrayelt",
"arrayelts : arrayelt",
"arrayelt : simpleexpr",
"arrayelt : init",
"opt_hashinit : hashinit",
"opt_hashinit : OC CC",
"opt_hashinit :",
"hashinit : OC hashelts opt_comma CC",
"hashelts : hashelts COMMA hashelt",
"hashelts : hashelt",
"hashelt : simpleexpr DARROW hashvalue",
"hashelt : DARROW hashvalue",
"hashvalue : simpleexpr",
"hashvalue : init",
"structinit : OC structelts opt_comma CC",
"structelts : structelts COMMA structelt",
"structelts : structelt",
"structelt : NAME ASSIGN simpleexpr",
"structelt : NAME ASSIGN init",
"structelt : DOT NAME ASSIGN simpleexpr",
"structelt : DOT NAME ASSIGN init",
"init : arrayinit",
"init : structinit",
"init : hashinit",
"init : OC CC",

};
#endif
/* define the initial stack-sizes */
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH  YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 500
#define YYMAXDEPTH  500
#endif
#endif

#define YYINITSTACKSIZE 500

int      yydebug;
int      yynerrs;

typedef struct {
    unsigned stacksize;
    short    *s_base;
    short    *s_mark;
    short    *s_last;
    YYSTYPE  *l_base;
    YYSTYPE  *l_mark;
} YYSTACKDATA;
int      yyerrflag;
int      yychar;
YYSTYPE  yyval;
YYSTYPE  yylval;

/* variables for the parser stack */
static YYSTACKDATA yystack;
#line 1624 "gram.y"

static void
DeclListMark (void *object)
{
    DeclListPtr	dl = object;

    MemReference (dl->next);
    MemReference (dl->init);
}

DataType DeclListType = { DeclListMark, 0, "DeclListType" };

DeclListPtr
NewDeclList (Atom name, ExprPtr init, DeclListPtr next)
{
    ENTER ();
    DeclListPtr	dl;

    dl = ALLOCATE (&DeclListType, sizeof (DeclList));
    dl->next = next;
    dl->name = name;
    dl->symbol = 0;
    dl->init = init;
    RETURN (dl);
}

static void
MemListMark (void *object)
{
    MemListPtr	ml = object;

    MemReference (ml->next);
    MemReference (ml->type);
    MemReference (ml->atoms);
}

DataType MemListType = { MemListMark, 0, "MemListType" };

MemListPtr
NewMemList (AtomListPtr atoms, Type *type, MemListPtr next)
{
    ENTER ();
    MemListPtr	ml;

    ml = ALLOCATE (&MemListType, sizeof (MemList));
    ml->next = next;
    ml->type = type;
    ml->atoms = atoms;
    RETURN (ml);
}


extern NamespacePtr	CurrentNamespace;
FramePtr	CurrentFrame;

Value
lookupVar (char *ns, char *n)
{
    ENTER ();
    Value	    v;
    SymbolPtr	    symbol;
    NamespacePtr    namespace;
    Bool	    search;

    search = True;
    namespace = CurrentNamespace;
    if (ns)
    {
	symbol = NamespaceFindName (CurrentNamespace, AtomId (ns), True);
	if (symbol && symbol->symbol.class == class_namespace)
	    namespace = symbol->namespace.namespace;
	else
	    namespace = 0;
    }
    if (namespace)
	symbol = NamespaceFindName (namespace, AtomId (n), search);
    else
	symbol = 0;
    if (symbol && symbol->symbol.class == class_global)
	v = BoxValue (symbol->global.value, 0);
    else
	v = Void;
    RETURN (v);
}

void
setVar (NamespacePtr namespace, char *n, Value v, Type *type)
{
    ENTER ();
    Atom	atom;
    SymbolPtr	symbol;

    atom = AtomId (n);
    symbol = NamespaceFindName (namespace, atom, True);
    if (!symbol)
	symbol = NamespaceAddName (namespace,
				   NewSymbolGlobal (atom, type),
				   publish_private);
    if (symbol->symbol.class == class_global)
	BoxValueSet (symbol->global.value, 0, v);
    EXIT ();
}

void
GetNamespace (NamespacePtr *scope, FramePtr *fp, CodePtr *cp)
{
    *scope = CurrentNamespace;
    *fp = CurrentFrame;
    if (CurrentFrame)
	*cp = CurrentFrame->function->func.code;
    else
	*cp = 0;
}

ExprPtr
BuildName (char *ns, char *n)
{
    ENTER ();
    SymbolPtr	    symbol, ns_symbol = 0;
    Atom	    atom, ns_atom = 0;
    Bool	    search = True;
    NamespacePtr    namespace = CurrentNamespace;
    ExprPtr	    e;
    Bool	    ns_privateFound = False;
    Bool	    privateFound = False;

    if (ns)
    {
	ns_atom = AtomId (ns);
	ns_symbol = NamespaceFindName (namespace, ns_atom, search);
	if (ns_symbol && ns_symbol->symbol.class == class_namespace)
	    namespace = ns_symbol->namespace.namespace;
	else
	{
	    if (!ns_symbol)
		ns_privateFound = NamespaceIsNamePrivate (namespace, ns_atom, search);
	    namespace = 0;
	}
	search = False;
    }
    atom = AtomId (n);
    if (namespace)
    {
	symbol = NamespaceFindName (namespace, atom, search);
	if (!symbol)
	    privateFound = NamespaceIsNamePrivate (namespace, atom, search);
    }
    else
	symbol = 0;
    e = NewExprAtom (atom, symbol, privateFound);
    if (ns_atom)
	e = NewExprTree (COLONCOLON, NewExprAtom (ns_atom, ns_symbol, ns_privateFound), e);
    RETURN (e);
}

static Value
AtomString (Atom id)
{
    ENTER ();
    RETURN (NewStrString (AtomName (id)));
}

ExprPtr
BuildRawname (ExprPtr colonnames, Atom name)
{
    ENTER ();
    int     len;
    Value   array;
    ExprPtr e;

    len = 1;
    for (e = colonnames; e; e = e->tree.left)
	len++;
    array = NewArray (False, False, typePrim[rep_string], 1, &len);
    len--;
    ArrayValueSet (&array->array, len, AtomString (name));
    e = colonnames;
    while (--len >= 0)
    {
	ArrayValueSet (&array->array, len, AtomString (e->tree.right->atom.atom));
	e = e->tree.left;
    }
    e = NewExprConst (POLY_CONST, array);
    RETURN (e);
}

	    
ExprPtr
BuildFullname (ExprPtr left, Atom atom)
{
    ENTER ();
    NamespacePtr    namespace;
    SymbolPtr	    symbol;
    Bool	    search;
    ExprPtr	    nameExpr;
    Bool	    privateFound = False;

    if (left)
    {
	if (left->base.tag == COLONCOLON)
	    symbol = left->tree.right->atom.symbol;
	else
	    symbol = left->atom.symbol;
	if (symbol && symbol->symbol.class == class_namespace)
	    namespace = symbol->namespace.namespace;
	else
	    namespace = 0;
        search = False;
    }
    else
    {
	namespace = CurrentNamespace;
	search = True;
    }
    if (namespace)
    {
	symbol = NamespaceFindName (namespace, atom, search);
	if (!symbol)
	    privateFound = NamespaceIsNamePrivate (namespace, atom, search);
    }
    else
	symbol = 0;
    nameExpr = NewExprAtom (atom, symbol, privateFound);
    if (left)
	nameExpr = NewExprTree (COLONCOLON, left, nameExpr);
    RETURN (nameExpr);
}

ExprPtr
BuildCall (char *scope, char *name, int nargs, ...)
{
    ENTER ();
    va_list	    alist;
    ExprPtr	    args, *prev;
    ExprPtr	    f;
    ExprPtr	    e;

    va_start (alist, nargs);
    prev = &args;
    args = 0;
    while (nargs--)
    {
	*prev = NewExprTree (COMMA, va_arg (alist, ExprPtr), 0);
	prev = &(*prev)->tree.right;
    }
    va_end (alist);
    f = BuildName (scope, name);
    e = NewExprTree (OP, f, args);
#ifdef DEBUG
    printExpr (stdout, e, -1, 0);
    printf ("\n");
#endif
    RETURN (e);
}

/*
 * Walk for() loop arguments and normalize the list
 */
static Expr *
ParseCanonFor (Expr *expr)
{
    if (!expr || !expr->tree.right) {
        ParseError ("Too few exprs in for()\n");
        return 0;
    }
    if (!expr->tree.right->tree.right) {
        /* 2-argument for() */
        expr = NewExprTree(FOR, 0, expr);
    }
    if (expr->tree.right->tree.right->tree.right) {
        ParseError ("Too many exprs in for()\n");
        return 0;
    }
    return expr;
}

/*
 * Walk a type structure and resolve any type names
 */
static CanonTypeResult
ParseCanonType (TypePtr type, Bool forwardAllowed)
{
    ArgType	    *arg;
    int		    n;
    CanonTypeResult ret = CanonTypeDefined, t;
    Bool	    anyResolved;
    
    if (!type)
    {
	ParseError ("Type missing inside compiler");
	return False;
    }
    switch (type->base.tag) {
    case type_prim:
	break;
    case type_name:
	if (!TypeNameType(type))
	{
	    if (!type->name.name)
	    {
		ExprPtr e;
		e = type->name.expr;
		if (e->base.tag == COLONCOLON)
		    e = e->tree.right;
		type->name.name = e->atom.symbol;
		if (!type->name.name)
		{
		    ParseError ("No typedef \"%A\" in namespace",
				e->atom.atom);
		    ret = CanonTypeUndefined;
		    break;
		}
	    }
	    if (type->name.name->symbol.class != class_typedef)
	    {
		ParseError ("Symbol \"%A\" not a typedef", 
			    type->name.name->symbol.name);
		ret = CanonTypeUndefined;
	    }
	    else if (!TypeNameType(type))
	    {
		if (!forwardAllowed)
		    ParseError ("Typedef \"%A\" not defined yet", 
				type->name.name->symbol.name);
		ret = CanonTypeForward;
	    }
	    else
	    {
		ret = ParseCanonType (TypeNameType(type), forwardAllowed);
	    }
	}
	break;
    case type_ref:
	ret = ParseCanonType (type->ref.ref, True);
	if (ret == CanonTypeForward)
	    ret = CanonTypeDefined;
	break;
    case type_func:
	if (type->func.ret)
	    ret = ParseCanonType (type->func.ret, forwardAllowed);
	for (arg = type->func.args; arg; arg = arg->next)
	{
	    t = ParseCanonType (arg->type, forwardAllowed);
	    if (t < ret)
		ret = t;
	}
	break;
    case type_array:
	ret = ParseCanonType (type->array.type, forwardAllowed);
	break;
    case type_hash:
	ret = ParseCanonType (type->hash.type, forwardAllowed);
	t = ParseCanonType (type->hash.keyType, forwardAllowed);
	if (t < ret)
	    ret = t;
	break;
    case type_struct:
	for (n = 0; n < type->structs.structs->nelements; n++)
	{
	    StructType   *st = type->structs.structs;

	    t = ParseCanonType (BoxTypesElements(st->types)[n], forwardAllowed);
	    if (t < ret)
		ret = t;
	}
	break;
    case type_union:
	anyResolved = False;
	for (n = 0; n < type->structs.structs->nelements; n++)
	{
	    StructType   *st = type->structs.structs;

	    t = ParseCanonType (BoxTypesElements(st->types)[n], True);
	    if (t < ret)
		ret = t;
	    if (t == CanonTypeDefined)
		anyResolved = True;
	}
	if (ret == CanonTypeForward)
	{
	    if (anyResolved)
		ret = CanonTypeDefined;
	    else if (!forwardAllowed)
		ParseError ("No member of '%T' defined yet", type);
	}
	break;
    case type_types:
	break;
    }
    return ret;
}

static SymbolPtr
ParseNewSymbol (Publish publish, Class class, Type *type, Atom name)
{
    ENTER ();
    SymbolPtr	s = 0;
    
    if (class == class_undef)
	class = funcDepth ? class_auto : class_global;

    if (class == class_namespace || 
	(class == class_typedef && type == 0) || 	
	ParseCanonType (type, False) == CanonTypeDefined)
    {
	switch (class) {
	case class_const:
	    s = NewSymbolConst (name, type);
	    break;
	case class_global:
	    s = NewSymbolGlobal (name, type);
	    break;
	case class_static:
	    s = NewSymbolStatic (name, type);
	    break;
	case class_arg:
	    s = NewSymbolArg (name, type);
	    break;
	case class_auto:
	    s = NewSymbolAuto (name, type);
	    break;
	case class_exception:
	    s = NewSymbolException (name, type, Void);
	    break;
	case class_typedef:
	    /*
	     * Special case for typedefs --
	     * allow forward declaration of untyped
	     * typedef names, then hook the
	     * new type to the old name
	     */
	    if (type)
	    {
		s = NamespaceFindName (CurrentNamespace, name, False);
		if (s && s->symbol.class == class_typedef && !s->symbol.type)
		{
		    s->symbol.type = type;
		    RETURN (s);
		}
	    }
	    s = NewSymbolType (name, type);
	    break;
	case class_namespace:
	    s = NewSymbolNamespace (name, NewNamespace (CurrentNamespace));
	    break;
	case class_undef:
	    break;
	}
	if (s)
	    NamespaceAddName (CurrentNamespace, s, publish);
    }
    RETURN (s);
}

int
yywrap (void)
{
    if (LexInteractive())
	printf ("\n");
    if (CurrentFrame)
    {
	do_Debug_done ();
	return 0;
    }
    return 1;
}

extern	char *yytext;

void
ParseError (char *fmt, ...)
{
    va_list	args;

    if (LexFileName ())
	FilePrintf (FileStderr, "%A:%d: ",
		    LexFileName (), LexFileLine ());
    va_start (args, fmt);
    FileVPrintf (FileStderr, fmt, args);
    FilePrintf (FileStderr, "\n");
    va_end (args);
}

void
yyerror (char *msg)
{
    ignorenl = 0;
    ParseError ("%s before %S", msg, yytext);
}
#line 2970 "gram.c"

#if YYDEBUG
#include <stdio.h>		/* needed for printf */
#endif

#include <stdlib.h>	/* needed for malloc, etc */
#include <string.h>	/* needed for memset */

/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack(YYSTACKDATA *data)
{
    int i;
    unsigned newsize;
    short *newss;
    YYSTYPE *newvs;

    if ((newsize = data->stacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return -1;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;

    i = data->s_mark - data->s_base;
    newss = (data->s_base != 0)
          ? (short *)realloc(data->s_base, newsize * sizeof(*newss))
          : (short *)malloc(newsize * sizeof(*newss));
    if (newss == 0)
        return -1;

    data->s_base = newss;
    data->s_mark = newss + i;

    newvs = (data->l_base != 0)
          ? (YYSTYPE *)realloc(data->l_base, newsize * sizeof(*newvs))
          : (YYSTYPE *)malloc(newsize * sizeof(*newvs));
    if (newvs == 0)
        return -1;

    data->l_base = newvs;
    data->l_mark = newvs + i;

    data->stacksize = newsize;
    data->s_last = data->s_base + newsize - 1;
    return 0;
}

#if YYPURE || defined(YY_NO_LEAKS)
static void yyfreestack(YYSTACKDATA *data)
{
    free(data->s_base);
    free(data->l_base);
    memset(data, 0, sizeof(*data));
}
#else
#define yyfreestack(data) /* nothing */
#endif

#define YYABORT  goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR  goto yyerrlab

int
YYPARSE_DECL()
{
    int yym, yyn, yystate;
#if YYDEBUG
    const char *yys;

    if ((yys = getenv("YYDEBUG")) != 0)
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = YYEMPTY;
    yystate = 0;

#if YYPURE
    memset(&yystack, 0, sizeof(yystack));
#endif

    if (yystack.s_base == NULL && yygrowstack(&yystack)) goto yyoverflow;
    yystack.s_mark = yystack.s_base;
    yystack.l_mark = yystack.l_base;
    yystate = 0;
    *yystack.s_mark = 0;

yyloop:
    if ((yyn = yydefred[yystate]) != 0) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = YYLEX) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack))
        {
            goto yyoverflow;
        }
        yystate = yytable[yyn];
        *++yystack.s_mark = yytable[yyn];
        *++yystack.l_mark = yylval;
        yychar = YYEMPTY;
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;

    yyerror("syntax error");

    goto yyerrlab;

yyerrlab:
    ++yynerrs;

yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yystack.s_mark]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yystack.s_mark, yytable[yyn]);
#endif
                if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack))
                {
                    goto yyoverflow;
                }
                yystate = yytable[yyn];
                *++yystack.s_mark = yytable[yyn];
                *++yystack.l_mark = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yystack.s_mark);
#endif
                if (yystack.s_mark <= yystack.s_base) goto yyabort;
                --yystack.s_mark;
                --yystack.l_mark;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = YYEMPTY;
        goto yyloop;
    }

yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    if (yym)
        yyval = yystack.l_mark[1-yym];
    else
        memset(&yyval, 0, sizeof yyval);
    switch (yyn)
    {
case 5:
#line 197 "gram.y"
	{ yyerrok; }
break;
case 6:
#line 199 "gram.y"
	{ yyerrok; }
break;
case 7:
#line 201 "gram.y"
	{ yyerrok; }
break;
case 8:
#line 209 "gram.y"
	{ ignorenl++; }
break;
case 9:
#line 212 "gram.y"
	{ if (ignorenl > 0) ignorenl--; }
break;
case 10:
#line 215 "gram.y"
	{ 
			ignorenl = 0; 
			LexNamespace = 0; 
			CurrentNamespace = TopNamespace; 
			funcDepth = 0; 
			notCommand = 0;
			lastThreadError = True;
		    }
break;
case 11:
#line 233 "gram.y"
	{ notCommand = 1; }
break;
case 18:
#line 248 "gram.y"
	{
			ENTER ();
			ExprPtr	e;
			Value	t;
			NamespacePtr	s;
			FramePtr	f;
			CodePtr		c;
			
			e = BuildCall ("Command", "display",
				       1,NewExprTree (EXPR, yystack.l_mark[-2].expr, 0));
			GetNamespace (&s, &f, &c);
			t = NewThread (f, CompileExpr (e, c));
			ThreadsRun (t, 0);
			EXIT ();
		    }
break;
case 19:
#line 264 "gram.y"
	{
			ENTER ();
			ExprPtr	e;
			Value	t;
			NamespacePtr	s;
			FramePtr	f;
			CodePtr		c;

			e = BuildCall("Command", "display_base",
				      2, NewExprTree (EXPR, yystack.l_mark[-4].expr, 0), yystack.l_mark[-2].expr);
			GetNamespace (&s, &f, &c);
			t = NewThread (f, CompileExpr (e, c));
			ThreadsRun (t, 0);
			EXIT ();
		    }
break;
case 20:
#line 280 "gram.y"
	{ 
			ENTER ();
			NamespacePtr    s;
			FramePtr	f;
			CodePtr		c;
			Value		t;
			
			GetNamespace (&s, &f, &c);
			t = NewThread (f, CompileStat (yystack.l_mark[-2].expr, c));
			ThreadsRun (t, 0);
			EXIT ();
		    }
break;
case 21:
#line 293 "gram.y"
	{
			ENTER();
			ExprPtr	e;
			Value	t;
			NamespacePtr	s;
			FramePtr	f;
			CodePtr		c;
			CommandPtr	cmd;

			cmd = CommandFind (CurrentCommands, yystack.l_mark[-4].atom);
			if (!cmd)
			    ParseError ("Undefined command \"%s\"", AtomName (yystack.l_mark[-4].atom));
			else
			{
			    e = NewExprTree (OP, 
					     NewExprConst (POLY_CONST, cmd->func),
					     yystack.l_mark[-3].expr);
			    GetNamespace (&s, &f, &c);
			    t = NewThread (f, CompileExpr (e, c));
			    ThreadsRun (t, 0);
			}
			EXIT ();
		    }
break;
case 22:
#line 317 "gram.y"
	{
			ENTER ();
			ExprPtr e;

			Value	t;
			NamespacePtr	s;
			FramePtr	f;
			CodePtr		c;
			CommandPtr	cmd;

			cmd = CommandFind (CurrentCommands, yystack.l_mark[-4].atom);
			if (!cmd)
			    ParseError ("Undefined command \"%s\"", AtomName (yystack.l_mark[-4].atom));
			else
			{
			    e = NewExprTree (OP, 
					     NewExprConst (POLY_CONST, cmd->func),
					     yystack.l_mark[-3].expr);
			    GetNamespace (&s, &f, &c);
			    t = NewThread (f, CompileExpr (e, c));
			    ThreadsRun (t, 0);
			}
			EXIT ();
		    }
break;
case 26:
#line 346 "gram.y"
	{ yyval.expr = 0; }
break;
case 27:
#line 349 "gram.y"
	{ yyval.expr = NewExprTree (COMMA, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
break;
case 28:
#line 351 "gram.y"
	{ yyval.expr = NewExprTree (COMMA, yystack.l_mark[0].expr, 0); }
break;
case 29:
#line 354 "gram.y"
	{ yyval.expr = BuildRawname (yystack.l_mark[-1].expr, yystack.l_mark[0].atom); }
break;
case 33:
#line 361 "gram.y"
	{ yyval.expr = NewExprTree (COLONCOLON, yystack.l_mark[-2].expr, NewExprAtom (yystack.l_mark[-1].atom, 0, False)); }
break;
case 34:
#line 363 "gram.y"
	{ yyval.expr = 0; }
break;
case 35:
#line 366 "gram.y"
	{ 
			yyval.expr = BuildFullname (yystack.l_mark[-1].expr, yystack.l_mark[0].atom);
			LexNamespace = 0;
		    }
break;
case 36:
#line 371 "gram.y"
	{ 
			yyval.expr = BuildFullname (0, yystack.l_mark[0].atom);
			LexNamespace = 0;
		    }
break;
case 37:
#line 377 "gram.y"
	{ 
			yyval.expr = BuildFullname (yystack.l_mark[-1].expr, yystack.l_mark[0].atom);
			LexNamespace = 0;
		    }
break;
case 38:
#line 382 "gram.y"
	{
			yyval.expr = BuildFullname (0, yystack.l_mark[0].atom);
			LexNamespace = 0;
		    }
break;
case 39:
#line 388 "gram.y"
	{
			yyval.expr = yystack.l_mark[0].expr;
		    }
break;
case 40:
#line 392 "gram.y"
	{
			yyval.expr = NewExprTree (COMMA, yystack.l_mark[-2].expr, yystack.l_mark[0].expr);
		    }
break;
case 41:
#line 397 "gram.y"
	{ 
			ExprPtr	    e;
			SymbolPtr   symbol;

			e = BuildFullname (yystack.l_mark[-2].expr, yystack.l_mark[-1].atom);
			if (e->base.tag == COLONCOLON)
			    symbol = e->tree.right->atom.symbol;
			else
			    symbol = e->atom.symbol;
			if (!symbol)
			{
			    ParseError ("non-existant namespace \"%A\"", yystack.l_mark[-1].atom);
			    YYERROR;
			}
			else if (symbol->symbol.class != class_namespace)
			{
			    ParseError ("%A is not a namespace", yystack.l_mark[-1].atom);
			    YYERROR;
			}
			LexNamespace = symbol->namespace.namespace;
			yyval.expr = e;
		    }
break;
case 42:
#line 420 "gram.y"
	{ 
			ExprPtr	    e;
			SymbolPtr   symbol;

			e = BuildFullname (0, yystack.l_mark[-1].atom);
			if (e->base.tag == COLONCOLON)
			    symbol = e->tree.right->atom.symbol;
			else
			    symbol = e->atom.symbol;
			if (!symbol)
			{
			    ParseError ("non-existant namespace \"%A\"", yystack.l_mark[-1].atom);
			    YYERROR;
			}
			else if (symbol->symbol.class != class_namespace)
			{
			    ParseError ("%A is not a namespace", yystack.l_mark[-1].atom);
			    YYERROR;
			}
			LexNamespace = symbol->namespace.namespace;
			yyval.expr = e;
		    }
break;
case 45:
#line 450 "gram.y"
	{ CurrentNamespace = NewNamespace (CurrentNamespace); }
break;
case 46:
#line 453 "gram.y"
	{ CurrentNamespace = CurrentNamespace->previous; }
break;
case 47:
#line 456 "gram.y"
	{ yyval.expr = yystack.l_mark[-1].expr; }
break;
case 50:
#line 463 "gram.y"
	{ yyval.expr = NewExprTree(OC, yystack.l_mark[-1].expr, yystack.l_mark[0].expr); }
break;
case 51:
#line 465 "gram.y"
	{ yyval.expr = NewExprTree(OC, 0, 0); }
break;
case 52:
#line 468 "gram.y"
	{ yyval.expr = NewExprTree(IF, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
break;
case 53:
#line 470 "gram.y"
	{ yyval.expr = NewExprTree(ELSE, yystack.l_mark[-4].expr, NewExprTree(ELSE, yystack.l_mark[-2].expr, yystack.l_mark[0].expr)); }
break;
case 56:
#line 477 "gram.y"
	{ yyval.expr = yystack.l_mark[-2].expr; }
break;
case 57:
#line 479 "gram.y"
	{ yyval.expr = NewExprTree(WHILE, yystack.l_mark[-4].expr, yystack.l_mark[-2].expr); }
break;
case 58:
#line 481 "gram.y"
	{ yyval.expr = NewExprTree(DO, yystack.l_mark[-6].expr, yystack.l_mark[-3].expr); }
break;
case 59:
#line 483 "gram.y"
	{ Expr *expr = ParseCanonFor(yystack.l_mark[-4].expr);
		      if (!expr)
                          YYERROR;
		      yyval.expr = NewExprTree(FOR, expr, yystack.l_mark[-2].expr); }
break;
case 60:
#line 488 "gram.y"
	{ yyval.expr = NewExprTree (SWITCH, yystack.l_mark[-4].expr, yystack.l_mark[-2].expr); }
break;
case 61:
#line 490 "gram.y"
	{ yyval.expr = NewExprTree (UNION, yystack.l_mark[-4].expr, yystack.l_mark[-2].expr); }
break;
case 62:
#line 492 "gram.y"
	{ yyval.expr = NewExprTree(BREAK, (Expr *) 0, (Expr *) 0); }
break;
case 63:
#line 494 "gram.y"
	{ yyval.expr = NewExprTree(CONTINUE, (Expr *) 0, (Expr *) 0); }
break;
case 64:
#line 496 "gram.y"
	{ yyval.expr = NewExprTree (RETURNTOK, (Expr *) 0, yystack.l_mark[-1].expr); }
break;
case 65:
#line 498 "gram.y"
	{ yyval.expr = NewExprTree(EXPR, yystack.l_mark[-1].expr, (Expr *) 0); }
break;
case 66:
#line 500 "gram.y"
	{ yyval.expr = NewExprTree(SEMI, (Expr *) 0, (Expr *) 0); }
break;
case 67:
#line 502 "gram.y"
	{ 
			DeclList    *decl = yystack.l_mark[-3].funcDecl.decl;
			SymbolPtr   symbol = decl->symbol;
			Class	    class = yystack.l_mark[-3].funcDecl.type.class;
			Publish	    publish = yystack.l_mark[-3].funcDecl.type.publish;
			TypePtr	    type = yystack.l_mark[-3].funcDecl.type.type;
			TypePtr	    ret = type->func.ret;
			ArgType	    *argType = type->func.args;

			if (symbol)
			{
			    if (yystack.l_mark[-1].expr)
			    {
				symbol->symbol.forward = False;
				ParseCanonType (ret, False);
				decl->init = NewExprCode (NewFuncCode (ret,
								       argType,
								       yystack.l_mark[-1].expr,
								       yystack.l_mark[-2].value),
							  NewExprAtom (symbol->symbol.name, symbol, False));
			    }
			    else
				symbol->symbol.forward = True;
			}
			yyval.expr = NewExprDecl (FUNC, decl, class, type, publish);
		    }
break;
case 68:
#line 529 "gram.y"
	{ 
			DeclListPtr decl;

			decl = NewDeclList (yystack.l_mark[-6].atom, 0, 0);
			decl->symbol = ParseNewSymbol (yystack.l_mark[-9].publish, 
						       class_exception, 
						       typePoly, yystack.l_mark[-6].atom);
			decl->symbol->exception.doc = yystack.l_mark[-2].value;
			yyval.expr = NewExprDecl (EXCEPTION,
					  decl,
					  class_exception,
					  NewTypeFunc (typePoly, yystack.l_mark[-4].argType),
					  yystack.l_mark[-9].publish);
		    }
break;
case 69:
#line 544 "gram.y"
	{ yyval.expr = NewExprTree (RAISE, yystack.l_mark[-4].expr, yystack.l_mark[-2].expr); }
break;
case 70:
#line 546 "gram.y"
	{ 
			DeclListPtr decl;

			for (decl = yystack.l_mark[-2].declList; decl; decl = decl->next)
			    decl->symbol = ParseNewSymbol (yystack.l_mark[-5].publish, class_typedef,
							   0, decl->name);
			yyval.expr = NewExprTree (TYPEDEF, NewExprDecl (TYPEDEF, yystack.l_mark[-2].declList, class_typedef, 0, yystack.l_mark[-5].publish), 0);
		    }
break;
case 71:
#line 555 "gram.y"
	{ 
			DeclListPtr decl;

			for (decl = yystack.l_mark[-2].declList; decl; decl = decl->next)
			    decl->symbol = ParseNewSymbol (yystack.l_mark[-6].publish, class_typedef,
							   yystack.l_mark[-3].type, decl->name);
			yyval.expr = NewExprTree (TYPEDEF, NewExprDecl (TYPEDEF, yystack.l_mark[-2].declList, class_typedef, yystack.l_mark[-3].type, yystack.l_mark[-6].publish), 0);
		    }
break;
case 72:
#line 564 "gram.y"
	{
			SymbolPtr   symbol;
			Publish	    publish = yystack.l_mark[-3].publish;
			
			/*
			 * this is a hack - save the current namespace
			 * on the parser stack to be restored after
			 * the block is compiled.
			 */
			yystack.l_mark[-2].namespace = CurrentNamespace;
			if (publish == publish_extend)
			{
			    symbol = NamespaceFindName (CurrentNamespace, yystack.l_mark[0].atom, True);
			    if (!symbol)
			    {
				ParseError ("non-existant namespace %A", yystack.l_mark[0].atom);
				YYERROR;
			    }
			    else if (symbol->symbol.class != class_namespace)
			    {
				ParseError ("%A is not a namespace", yystack.l_mark[0].atom);
				YYERROR;
			    }
			    else
				CurrentNamespace = symbol->namespace.namespace;
			}
			else
			{
			    symbol = ParseNewSymbol (yystack.l_mark[-3].publish, class_namespace,
						     0, yystack.l_mark[0].atom);
			    CurrentNamespace = NewNamespace (CurrentNamespace);
			    symbol->namespace.namespace = CurrentNamespace;
			}
			/*
			 * Make all of the symbols visible while compiling within
			 * the namespace
			 */
			if (CurrentNamespace != yystack.l_mark[-2].namespace)
			    CurrentNamespace->publish = publish_public;
		    }
break;
case 73:
#line 605 "gram.y"
	{
			/*
			 * close the namespace to non-public lookups
			 */
			if (CurrentNamespace != yystack.l_mark[-7].namespace)
			    CurrentNamespace->publish = publish_private;
			/*
			 * Restore to the namespace saved on
			 * the parser stack
			 */
			CurrentNamespace = yystack.l_mark[-7].namespace;
			yyval.expr = NewExprTree (NAMESPACE, NewExprAtom (yystack.l_mark[-5].atom, 0, False), yystack.l_mark[-2].expr);
		    }
break;
case 74:
#line 619 "gram.y"
	{
			SymbolPtr	symbol;
			ExprPtr		p, e, n;

			p = yystack.l_mark[-2].expr;
			for (p = yystack.l_mark[-2].expr; p; p = n)
			{
			    if (p->base.tag == COMMA)
			    {
				e = p->tree.left;
				n = p->tree.right;
			    }
			    else
			    {
				e = p;
				n = 0;
			    }
			    if (e->base.tag == COLONCOLON)
				e = e->tree.right;
			    symbol = e->atom.symbol;
			    if (!symbol)
			    {
				ParseError ("non-existant namespace %A", e->atom.atom);
				YYERROR;
			    }
			    else if (symbol->symbol.class != class_namespace)
			    {
				ParseError ("%A is not a namespace", e->atom.atom);
				YYERROR;
			    }
			    NamespaceImport (CurrentNamespace, 
					     symbol->namespace.namespace, yystack.l_mark[-5].publish);
			}
			yyval.expr = NewExprTree (IMPORT, yystack.l_mark[-2].expr, NewExprDecl (IMPORT,
								   0, 
								   class_undef,
								   0,
								   yystack.l_mark[-5].publish));
		    }
break;
case 75:
#line 659 "gram.y"
	{ yyval.expr = yystack.l_mark[-1].expr; }
break;
case 76:
#line 661 "gram.y"
	{ yyval.expr = NewExprTree (TWIXT, 
					NewExprTree (TWIXT, yystack.l_mark[-6].expr, yystack.l_mark[-4].expr),
					NewExprTree (TWIXT, yystack.l_mark[-2].expr, 0));
		    }
break;
case 77:
#line 667 "gram.y"
	{ yyval.expr = NewExprTree(SEMI, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
break;
case 78:
#line 669 "gram.y"
	{ yyval.expr = NewExprTree(SEMI, yystack.l_mark[0].expr, 0); }
break;
case 80:
#line 674 "gram.y"
	{ yyval.expr = yystack.l_mark[-1].expr; }
break;
case 81:
#line 677 "gram.y"
	{ yyval.expr = NewExprTree (CATCH, yystack.l_mark[0].expr, yystack.l_mark[-1].expr); }
break;
case 82:
#line 681 "gram.y"
	{ yyval.expr = NewExprTree (CATCH, yystack.l_mark[-1].expr, yystack.l_mark[0].expr); }
break;
case 83:
#line 683 "gram.y"
	{ yyval.expr = 0; }
break;
case 84:
#line 686 "gram.y"
	{ yyval.expr = NewExprCode (NewFuncCode (typePrim[rep_void],
						     yystack.l_mark[-3].argType, yystack.l_mark[-1].expr, yystack.l_mark[-2].value),
					yystack.l_mark[-5].expr); 
		    }
break;
case 86:
#line 693 "gram.y"
	{ yyval.expr = 0; }
break;
case 87:
#line 695 "gram.y"
	{ ++funcDepth; }
break;
case 88:
#line 695 "gram.y"
	{ --funcDepth; yyval.expr = yystack.l_mark[0].expr; }
break;
case 89:
#line 698 "gram.y"
	{ yyval.expr = yystack.l_mark[0].expr; }
break;
case 90:
#line 700 "gram.y"
	{ 
			yyval.expr = NewExprTree (OC,
					  NewExprTree (RETURNTOK, 0, yystack.l_mark[-1].expr),
					  NewExprTree (OC, 0, 0));
		    }
break;
case 93:
#line 710 "gram.y"
	{ seeComment = 1; }
break;
case 94:
#line 713 "gram.y"
	{ seeComment = 0; yyval.value = yystack.l_mark[0].value; }
break;
case 96:
#line 717 "gram.y"
	{ yyval.value = Void; }
break;
case 97:
#line 720 "gram.y"
	{ yyval.expr = yystack.l_mark[-1].expr; }
break;
case 98:
#line 723 "gram.y"
	{ yyval.expr = NewExprTree (CASE, yystack.l_mark[-1].expr, yystack.l_mark[0].expr); }
break;
case 99:
#line 725 "gram.y"
	{ yyval.expr = 0; }
break;
case 100:
#line 728 "gram.y"
	{ yyval.expr = NewExprTree (CASE, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
break;
case 101:
#line 730 "gram.y"
	{ yyval.expr = NewExprTree (CASE, 0, yystack.l_mark[0].expr); }
break;
case 102:
#line 733 "gram.y"
	{ yyval.expr = yystack.l_mark[-1].expr; }
break;
case 103:
#line 736 "gram.y"
	{ yyval.expr = NewExprTree (CASE, yystack.l_mark[-1].expr, yystack.l_mark[0].expr); }
break;
case 104:
#line 738 "gram.y"
	{ yyval.expr = 0; }
break;
case 105:
#line 741 "gram.y"
	{ 
			SymbolPtr   sym = yystack.l_mark[-3].symbol;
			Atom	    sym_atom = sym ? sym->symbol.name : 0;
			ExprPtr	    name = 0;
			
			if (sym)
			    name = NewExprAtom (sym_atom, sym, False);
			    
			yyval.expr = NewExprTree (CASE, 
					  NewExprTree (CASE,
						       NewExprAtom (yystack.l_mark[-4].atom, 0, False),
						       name),
					  yystack.l_mark[-1].expr);
		    }
break;
case 106:
#line 756 "gram.y"
	{ yyval.expr = NewExprTree (CASE, 0, yystack.l_mark[0].expr); }
break;
case 107:
#line 759 "gram.y"
	{
			yyval.symbol = ParseNewSymbol (publish_private,
					     class_undef,
					     typePoly,
					     yystack.l_mark[0].atom);
		    }
break;
case 108:
#line 766 "gram.y"
	{ yyval.symbol = 0; }
break;
case 109:
#line 772 "gram.y"
	{ yyval.atomList = NewAtomList (yystack.l_mark[0].atomList, yystack.l_mark[-2].atom); }
break;
case 110:
#line 774 "gram.y"
	{ yyval.atomList = NewAtomList (0, yystack.l_mark[0].atom); }
break;
case 111:
#line 777 "gram.y"
	{ yyval.declList = NewDeclList (yystack.l_mark[-2].atom, 0, yystack.l_mark[0].declList); }
break;
case 112:
#line 779 "gram.y"
	{ yyval.declList = NewDeclList (yystack.l_mark[0].atom, 0, 0); }
break;
case 115:
#line 793 "gram.y"
	{ 
			if (yystack.l_mark[-3].symbol)
			{
			    yyval.declList = NewDeclList (yystack.l_mark[-3].symbol->symbol.name, yystack.l_mark[-2].expr, yystack.l_mark[0].declList); 
			    yyval.declList->symbol = yystack.l_mark[-3].symbol;
			}
			else
			    yyval.declList = yystack.l_mark[0].declList;
		    }
break;
case 116:
#line 803 "gram.y"
	{ 
			if (yystack.l_mark[-1].symbol)
			{
			    yyval.declList = NewDeclList (yystack.l_mark[-1].symbol->symbol.name, yystack.l_mark[0].expr, 0);
			    yyval.declList->symbol = yystack.l_mark[-1].symbol;
			}
			else
			    yystack.l_mark[-1].symbol = 0;
		    }
break;
case 117:
#line 814 "gram.y"
	{	
			yyval.symbol = ParseNewSymbol (yystack.l_mark[-1].fulltype.publish,
					     yystack.l_mark[-1].fulltype.class,
					     yystack.l_mark[-1].fulltype.type,
					     yystack.l_mark[0].atom);
		    }
break;
case 118:
#line 826 "gram.y"
	{ yyval.fulltype = yystack.l_mark[-3].fulltype; }
break;
case 119:
#line 832 "gram.y"
	{
			NamespacePtr	save = CurrentNamespace;
			SymbolPtr	symbol;
			Type		*type = NewTypeFunc (yystack.l_mark[-3].funcDecl.type.type, yystack.l_mark[-1].argType);
			/*
			 * namespace_start pushed a new namespace, make sure
			 * this symbol is placed in the original namespace
			 */
			CurrentNamespace = save->previous;
			symbol = NamespaceFindName (CurrentNamespace, yystack.l_mark[-3].funcDecl.decl->name, True);
			if (symbol && symbol->symbol.forward)
			{
			    if (!TypeIsSupertype (symbol->symbol.type, type))
			    {
				ParseError ("%A redefinition with different type",
					    yystack.l_mark[-3].funcDecl.decl->name);
				symbol = 0;
			    }
			}
			else
			{
			    symbol = ParseNewSymbol (yystack.l_mark[-3].funcDecl.type.publish,
						     yystack.l_mark[-3].funcDecl.type.class, 
						     type,
						     yystack.l_mark[-3].funcDecl.decl->name);
			}
			CurrentNamespace = save;
			yyval.funcDecl = yystack.l_mark[-3].funcDecl;
			yyval.funcDecl.decl->symbol = symbol;
			yyval.funcDecl.type.type = type;
		    }
break;
case 120:
#line 865 "gram.y"
	{ yyval.funcDecl.type = yystack.l_mark[-2].fulltype; yyval.funcDecl.decl = NewDeclList (yystack.l_mark[-1].atom, 0, 0); }
break;
case 121:
#line 867 "gram.y"
	{ yyval.funcDecl.type = yystack.l_mark[-3].fulltype; yyval.funcDecl.decl = NewDeclList (yystack.l_mark[-1].atom, 0, 0); }
break;
case 122:
#line 869 "gram.y"
	{ 
			yyval.funcDecl.type.publish = publish_private;
			yyval.funcDecl.type.class = class_undef;
			yyval.funcDecl.type.type = typePoly;
			yyval.funcDecl.decl = NewDeclList (yystack.l_mark[-1].atom, 0, 0); 
		    }
break;
case 123:
#line 877 "gram.y"
	{ yyval.expr = yystack.l_mark[0].expr; }
break;
case 124:
#line 879 "gram.y"
	{ yyval.expr = yystack.l_mark[0].expr; }
break;
case 125:
#line 881 "gram.y"
	{ yyval.expr = 0; }
break;
case 126:
#line 887 "gram.y"
	{ yyval.fulltype.publish = yystack.l_mark[-3].publish; yyval.fulltype.class = yystack.l_mark[-2].class; yyval.fulltype.type = yystack.l_mark[-1].type; }
break;
case 127:
#line 889 "gram.y"
	{ yyval.fulltype.publish = publish_private; yyval.fulltype.class = yystack.l_mark[-2].class; yyval.fulltype.type = yystack.l_mark[-1].type; }
break;
case 128:
#line 891 "gram.y"
	{ yyval.fulltype.publish = publish_private; yyval.fulltype.class = class_undef; yyval.fulltype.type = yystack.l_mark[-1].type; }
break;
case 129:
#line 897 "gram.y"
	{ yyval.type = NewTypeFunc (yystack.l_mark[0].type, yystack.l_mark[-1].argType); }
break;
case 130:
#line 899 "gram.y"
	{ yyval.type = NewTypeArray (yystack.l_mark[0].type, yystack.l_mark[-2].expr, False); }
break;
case 131:
#line 901 "gram.y"
	{ yyval.type = NewTypeArray (yystack.l_mark[0].type, yystack.l_mark[-2].expr, True); }
break;
case 132:
#line 903 "gram.y"
	{ yyval.type = NewTypeArray (yystack.l_mark[0].type, yystack.l_mark[-2].expr, False); }
break;
case 133:
#line 905 "gram.y"
	{ yyval.type = NewTypeHash (yystack.l_mark[0].type, yystack.l_mark[-2].type); }
break;
case 134:
#line 907 "gram.y"
	{ yyval.type = 0; }
break;
case 135:
#line 910 "gram.y"
	{
			Type	*top = yystack.l_mark[0].type;
			Type	*t, **bot = &top;

			/*
			 * Walk down the type chain to hang the
			 * base type off of the end.  This
			 * makes int[]() be an array of functions
			 * rather than a function returning an array
			 */
			while ((t = *bot))
			    switch (t->base.tag) {
			    case type_array:
				bot = &t->array.type;
				break;
			    case type_hash:
				bot = &t->hash.type;
				break;
			    case type_func:
				bot = &t->func.ret;
				break;
			    default:
				assert(0);
			    }
			*bot = yystack.l_mark[-1].type;
			yyval.type = top;
		    }
break;
case 136:
#line 938 "gram.y"
	{ yyval.type = NewTypeRef (yystack.l_mark[0].type, True); }
break;
case 137:
#line 940 "gram.y"
	{ yyval.type = NewTypeRef (NewTypeRef (yystack.l_mark[0].type, True), True); }
break;
case 138:
#line 942 "gram.y"
	{ yyval.type = NewTypeRef (NewTypeRef (yystack.l_mark[0].type, False), False); }
break;
case 139:
#line 944 "gram.y"
	{ yyval.type = NewTypeRef (yystack.l_mark[0].type, False); }
break;
case 140:
#line 946 "gram.y"
	{ 
			if (ParseCanonType (yystack.l_mark[-2].type, False) != CanonTypeDefined)
			    YYERROR;
			if (ParseCanonType (yystack.l_mark[0].type, False) != CanonTypeDefined)
			    YYERROR;
			yyval.type = NewTypePlus (yystack.l_mark[-2].type, yystack.l_mark[0].type); 
			if (!yyval.type)
			    YYERROR;
		    }
break;
case 142:
#line 958 "gram.y"
	{
			AtomListPtr	al;
			StructType	*st;
			MemListPtr	ml;
			int		nelements;

			nelements = 0;
			for (ml = yystack.l_mark[-1].memList; ml; ml = ml->next)
			{
			    for (al = ml->atoms; al; al = al->next)
				nelements++;
			}
			st = NewStructType (nelements);
			nelements = 0;
			for (ml = yystack.l_mark[-1].memList; ml; ml = ml->next)
			{
			    for (al = ml->atoms; al; al = al->next)
			    {
				AddBoxType (&st->types, ml->type);
				StructTypeAtoms(st)[nelements] = al->atom;
				nelements++;
			    }
			}
			yyval.type = NewTypeStruct (st);
		    }
break;
case 143:
#line 984 "gram.y"
	{
			AtomListPtr	al;
			StructType	*st;
			MemListPtr	ml;
			int		nelements;

			nelements = 0;
			for (ml = yystack.l_mark[-1].memList; ml; ml = ml->next)
			{
			    for (al = ml->atoms; al; al = al->next)
				nelements++;
			}
			st = NewStructType (nelements);
			nelements = 0;
			for (ml = yystack.l_mark[-1].memList; ml; ml = ml->next)
			{
			    for (al = ml->atoms; al; al = al->next)
			    {
				AddBoxType (&st->types, ml->type);
				StructTypeAtoms(st)[nelements] = al->atom;
				nelements++;
			    }
			}
			yyval.type = NewTypeUnion (st, False);
		    }
break;
case 144:
#line 1010 "gram.y"
	{
			AtomListPtr	al;
			StructType	*st;
			int		nelements;

			nelements = 0;
			for (al = yystack.l_mark[-1].atomList; al; al = al->next)
			    nelements++;
			
			st = NewStructType (nelements);
			nelements = 0;
			for (al = yystack.l_mark[-1].atomList; al; al = al->next)
			{
			    AddBoxType (&st->types, typePrim[rep_void]);
			    StructTypeAtoms(st)[nelements] = al->atom;
			    nelements++;
			}
			yyval.type = NewTypeUnion (st, True);
		    }
break;
case 145:
#line 1031 "gram.y"
	{ yyval.type = yystack.l_mark[-1].type; }
break;
case 146:
#line 1033 "gram.y"
	{ yyval.type = NewTypeName (yystack.l_mark[0].expr, 0); }
break;
case 148:
#line 1037 "gram.y"
	{ yyval.type = typePoly; }
break;
case 163:
#line 1055 "gram.y"
	{ yyval.expr = 0; }
break;
case 164:
#line 1058 "gram.y"
	{ yyval.expr = NewExprTree (COMMA, 0, yystack.l_mark[-2].expr); }
break;
case 165:
#line 1060 "gram.y"
	{ yyval.expr = NewExprTree (COMMA, 0, 0); }
break;
case 166:
#line 1063 "gram.y"
	{ yyval.expr = NewExprTree (COMMA, 0, yystack.l_mark[-2].expr); }
break;
case 167:
#line 1065 "gram.y"
	{ yyval.expr = NewExprTree (COMMA, 0, 0); }
break;
case 168:
#line 1068 "gram.y"
	{ yyval.expr = NewExprTree (COMMA, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
break;
case 169:
#line 1070 "gram.y"
	{ yyval.expr = NewExprTree (COMMA, yystack.l_mark[0].expr, 0); }
break;
case 170:
#line 1076 "gram.y"
	{ yyval.memList = NewMemList (yystack.l_mark[-2].atomList, yystack.l_mark[-3].type, yystack.l_mark[0].memList); }
break;
case 171:
#line 1078 "gram.y"
	{ yyval.memList = 0; }
break;
case 172:
#line 1081 "gram.y"
	{ yyval.memList = NewMemList (yystack.l_mark[-2].atomList, yystack.l_mark[-3].type, yystack.l_mark[0].memList); }
break;
case 173:
#line 1083 "gram.y"
	{ yyval.memList = 0; }
break;
case 175:
#line 1090 "gram.y"
	{ yyval.class = class_undef; }
break;
case 181:
#line 1099 "gram.y"
	{ yyval.publish = publish_private; }
break;
case 186:
#line 1113 "gram.y"
	{ yyval.argType = yystack.l_mark[-1].argType; }
break;
case 187:
#line 1115 "gram.y"
	{ yyval.argType = 0; }
break;
case 188:
#line 1118 "gram.y"
	{ yyval.argType = NewArgType (yystack.l_mark[-2].argDecl.type, False, yystack.l_mark[-2].argDecl.name, 0, yystack.l_mark[0].argType); }
break;
case 189:
#line 1120 "gram.y"
	{ yyval.argType = NewArgType (yystack.l_mark[-1].argDecl.type, yystack.l_mark[0].bool, yystack.l_mark[-1].argDecl.name, 0, 0); }
break;
case 190:
#line 1123 "gram.y"
	{ 
			ParseCanonType (yystack.l_mark[-1].type, False);
			yyval.argDecl.type = yystack.l_mark[-1].type; 
			yyval.argDecl.name = yystack.l_mark[0].atom; 
		    }
break;
case 191:
#line 1129 "gram.y"
	{ 
			ParseCanonType (yystack.l_mark[0].type, False);
			yyval.argDecl.type = yystack.l_mark[0].type;
			yyval.argDecl.name = 0; 
		    }
break;
case 192:
#line 1140 "gram.y"
	{ yyval.argType = yystack.l_mark[-1].argType; }
break;
case 193:
#line 1143 "gram.y"
	{
			ArgType	*args;
			Type	*type;

			for (args = yystack.l_mark[0].argType; args; args = args->next)
			{
			    type = args->type;
			    if (ParseCanonType (type, False) != CanonTypeDefined)
				break;
			    if (args->varargs)
			    {
				type = NewTypeArray (type,
						     NewExprTree (COMMA,
								  NewExprConst (TEN_NUM, 
										NewInt (0)),
								  0),
						     False);
			    }
			    args->symbol = ParseNewSymbol (publish_private,
							   class_arg, 
							   type, args->name);
			}
			yyval.argType = yystack.l_mark[0].argType;
		    }
break;
case 194:
#line 1168 "gram.y"
	{ yyval.argType = 0; }
break;
case 195:
#line 1171 "gram.y"
	{ yyval.argType = NewArgType (yystack.l_mark[-2].argDecl.type, False, yystack.l_mark[-2].argDecl.name, 0, yystack.l_mark[0].argType); }
break;
case 196:
#line 1173 "gram.y"
	{ yyval.argType = NewArgType (yystack.l_mark[-1].argDecl.type, yystack.l_mark[0].bool, yystack.l_mark[-1].argDecl.name, 0, 0); }
break;
case 197:
#line 1176 "gram.y"
	{ yyval.argDecl.type = yystack.l_mark[-1].type; yyval.argDecl.name = yystack.l_mark[0].atom; }
break;
case 198:
#line 1178 "gram.y"
	{ yyval.argDecl.type = yystack.l_mark[0].type; yyval.argDecl.name = 0; }
break;
case 199:
#line 1181 "gram.y"
	{ yyval.bool = True; }
break;
case 200:
#line 1183 "gram.y"
	{ yyval.bool = False; }
break;
case 202:
#line 1191 "gram.y"
	{ yyval.expr = 0; }
break;
case 204:
#line 1195 "gram.y"
	{ 
			DeclList    *decl;

			for (decl = yystack.l_mark[0].declList; decl; decl = decl->next)
			{
			    if (decl->init)
			    {
				if (!decl->init->base.type)
				    decl->init->base.type = yystack.l_mark[-1].fulltype.type;
			    }
			}

			yyval.expr = NewExprDecl (VAR, yystack.l_mark[0].declList, yystack.l_mark[-1].fulltype.class, yystack.l_mark[-1].fulltype.type, yystack.l_mark[-1].fulltype.publish); 
		    }
break;
case 206:
#line 1212 "gram.y"
	{ yyval.expr = NewExprTree(COMMA, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
break;
case 208:
#line 1219 "gram.y"
	{ yyval.expr = 0; }
break;
case 209:
#line 1222 "gram.y"
	{ yyval.expr = NewExprTree (COMMA, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
break;
case 210:
#line 1224 "gram.y"
	{ yyval.expr = NewExprTree (COMMA, yystack.l_mark[0].expr, 0); }
break;
case 212:
#line 1228 "gram.y"
	{ yyval.expr = 0; }
break;
case 213:
#line 1231 "gram.y"
	{ yyval.expr = NewExprTree (COMMA, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
break;
case 214:
#line 1233 "gram.y"
	{	
			ExprPtr	arg = yystack.l_mark[0].bool ? NewExprTree (DOTDOTDOT, yystack.l_mark[-1].expr, 0) : yystack.l_mark[-1].expr;
			yyval.expr = NewExprTree (COMMA, arg, 0); 
		    }
break;
case 215:
#line 1239 "gram.y"
	{ 
			yyval.expr = NewExprTree (OC,
					  NewExprTree (RETURNTOK, 0, yystack.l_mark[0].expr),
					  NewExprTree (OC, 0, 0));
		    }
break;
case 216:
#line 1244 "gram.y"
	{ ++funcDepth; }
break;
case 217:
#line 1244 "gram.y"
	{ --funcDepth; yyval.expr = yystack.l_mark[0].expr; }
break;
case 218:
#line 1250 "gram.y"
	{ 
			if (yystack.l_mark[-1].ints == ASSIGNPOW)
			    yyval.expr = NewExprTree (ASSIGNPOW, 
					      BuildName ("Math", "assign_pow"),
					      NewExprTree (ASSIGNPOW, yystack.l_mark[-2].expr, yystack.l_mark[0].expr));
			else
			{
			    ExprPtr left = yystack.l_mark[-2].expr;
			    /*
			     * Automatically declare names used in
			     * simple assignements at the top level
			     */
			    if (yystack.l_mark[-1].ints == ASSIGN && 
				funcDepth == 0 &&
				left->base.tag == NAME && 
				!(left->atom.symbol))
			    {
				yystack.l_mark[-2].expr->atom.symbol = ParseNewSymbol (publish_private,
								  class_undef, 
								  typePoly, 
								  yystack.l_mark[-2].expr->atom.atom);
			    }
			    yyval.expr = NewExprTree(yystack.l_mark[-1].ints, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); 
			}
		    }
break;
case 219:
#line 1276 "gram.y"
	{
			ParseCanonType (yystack.l_mark[-6].type, False);
			yyval.expr = NewExprCode (NewFuncCode (yystack.l_mark[-6].type, yystack.l_mark[-3].argType, yystack.l_mark[-1].expr, yystack.l_mark[-2].value), 0); 
		    }
break;
case 220:
#line 1281 "gram.y"
	{   Value	t;
			t = do_Thread_id_to_thread (yystack.l_mark[0].value);
			if (t == Void)
			{
			    ParseError ("No thread %v", yystack.l_mark[0].value);
			    YYERROR;
			}
			else
			    yyval.expr = NewExprConst(THREAD_CONST, t); 
		    }
break;
case 221:
#line 1292 "gram.y"
	{ yyval.expr = NewExprTree(STAR, yystack.l_mark[0].expr, (Expr *) 0); }
break;
case 222:
#line 1294 "gram.y"
	{ yyval.expr = NewExprTree(STAR, NewExprTree (STAR, yystack.l_mark[0].expr, 0), 0); }
break;
case 223:
#line 1296 "gram.y"
	{ yyval.expr = NewExprTree(AMPER, yystack.l_mark[0].expr, (Expr *) 0); }
break;
case 224:
#line 1298 "gram.y"
	{ yyval.expr = NewExprTree(AMPER, 
				       NewExprTree (AMPER, yystack.l_mark[0].expr, (Expr *) 0), 
				       (Expr *) 0); }
break;
case 225:
#line 1302 "gram.y"
	{ yyval.expr = NewExprTree(UMINUS, yystack.l_mark[0].expr, (Expr *) 0); }
break;
case 226:
#line 1304 "gram.y"
	{ yyval.expr = NewExprTree(LNOT, yystack.l_mark[0].expr, (Expr *) 0); }
break;
case 227:
#line 1306 "gram.y"
	{ yyval.expr = NewExprTree(BANG, yystack.l_mark[0].expr, (Expr *) 0); }
break;
case 228:
#line 1308 "gram.y"
	{ 
			yyval.expr = NewExprTree(FACT, 
					 BuildName ("Math", "factorial"),
					 yystack.l_mark[-1].expr);
		    }
break;
case 229:
#line 1314 "gram.y"
	{ yyval.expr = NewExprTree(INC, yystack.l_mark[0].expr, (Expr *) 0); }
break;
case 230:
#line 1316 "gram.y"
	{ yyval.expr = NewExprTree(INC, (Expr *) 0, yystack.l_mark[-1].expr); }
break;
case 231:
#line 1318 "gram.y"
	{ yyval.expr = NewExprTree(DEC, yystack.l_mark[0].expr, (Expr *) 0); }
break;
case 232:
#line 1320 "gram.y"
	{ yyval.expr = NewExprTree(DEC, (Expr *) 0, yystack.l_mark[-1].expr); }
break;
case 233:
#line 1322 "gram.y"
	{ yyval.expr = NewExprTree (FORK, (Expr *) 0, yystack.l_mark[0].expr); }
break;
case 234:
#line 1324 "gram.y"
	{ yyval.expr = NewExprTree(PLUS, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
break;
case 235:
#line 1326 "gram.y"
	{ yyval.expr = NewExprTree(MINUS, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
break;
case 236:
#line 1328 "gram.y"
	{ yyval.expr = NewExprTree(TIMES, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
break;
case 237:
#line 1330 "gram.y"
	{ yyval.expr = NewExprTree(DIVIDE, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
break;
case 238:
#line 1332 "gram.y"
	{ yyval.expr = NewExprTree(DIV, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
break;
case 239:
#line 1334 "gram.y"
	{ yyval.expr = NewExprTree(MOD, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
break;
case 240:
#line 1336 "gram.y"
	{ 
			yyval.expr = NewExprTree(POW, 
					 BuildName ("Math", "pow"), 
					 NewExprTree (POW, yystack.l_mark[-2].expr, yystack.l_mark[0].expr)); 
		    }
break;
case 241:
#line 1342 "gram.y"
	{
			yyval.expr = NewExprTree (POW,
					  BuildName("Math", "pow"),
					  NewExprTree (POW, yystack.l_mark[-1].expr,
						       NewExprConst (TEN_NUM,
								     NewInt(2))));
		    }
break;
case 242:
#line 1350 "gram.y"
	{
			yyval.expr = NewExprTree (POW,
					  BuildName("Math", "pow"),
					  NewExprTree (POW, yystack.l_mark[-1].expr,
						       NewExprConst (TEN_NUM,
								     NewInt(3))));
		    }
break;
case 243:
#line 1358 "gram.y"
	{ yyval.expr = NewExprTree(SHIFTL, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
break;
case 244:
#line 1360 "gram.y"
	{ yyval.expr = NewExprTree(SHIFTR, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
break;
case 245:
#line 1362 "gram.y"
	{ yyval.expr = NewExprTree(QUEST, yystack.l_mark[-4].expr, NewExprTree(COLON, yystack.l_mark[-2].expr, yystack.l_mark[0].expr)); }
break;
case 246:
#line 1364 "gram.y"
	{ yyval.expr = NewExprTree(LXOR, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
break;
case 247:
#line 1366 "gram.y"
	{ yyval.expr = NewExprTree(LAND, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
break;
case 248:
#line 1368 "gram.y"
	{ yyval.expr = NewExprTree(LOR, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
break;
case 249:
#line 1370 "gram.y"
	{ yyval.expr = NewExprTree(AND, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
break;
case 250:
#line 1372 "gram.y"
	{ yyval.expr = NewExprTree(OR, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
break;
case 251:
#line 1374 "gram.y"
	{ yyval.expr = NewExprTree(EQ, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
break;
case 252:
#line 1376 "gram.y"
	{ yyval.expr = NewExprTree(NE, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
break;
case 253:
#line 1378 "gram.y"
	{ yyval.expr = NewExprTree(LT, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
break;
case 254:
#line 1380 "gram.y"
	{ yyval.expr = NewExprTree(GT, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
break;
case 255:
#line 1382 "gram.y"
	{ yyval.expr = NewExprTree(LE, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
break;
case 256:
#line 1384 "gram.y"
	{ yyval.expr = NewExprTree(GE, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
break;
case 258:
#line 1387 "gram.y"
	{ yyval.expr = NewExprConst(TEN_NUM, yystack.l_mark[0].value); }
break;
case 259:
#line 1389 "gram.y"
	{ yyval.expr = NewExprConst(OCTAL_NUM, yystack.l_mark[0].value); }
break;
case 260:
#line 1391 "gram.y"
	{ yyval.expr = NewExprConst(OCTAL0_NUM, yystack.l_mark[0].value); }
break;
case 261:
#line 1393 "gram.y"
	{ yyval.expr = NewExprConst(BINARY_NUM, yystack.l_mark[0].value); }
break;
case 262:
#line 1395 "gram.y"
	{ yyval.expr = NewExprConst(HEX_NUM, yystack.l_mark[0].value); }
break;
case 263:
#line 1397 "gram.y"
	{ yyval.expr = NewExprConst(TEN_FLOAT, yystack.l_mark[0].value); }
break;
case 264:
#line 1399 "gram.y"
	{ yyval.expr = NewExprConst(OCTAL_FLOAT, yystack.l_mark[0].value); }
break;
case 265:
#line 1401 "gram.y"
	{ yyval.expr = NewExprConst(OCTAL0_FLOAT, yystack.l_mark[0].value); }
break;
case 266:
#line 1403 "gram.y"
	{ yyval.expr = NewExprConst(BINARY_FLOAT, yystack.l_mark[0].value); }
break;
case 267:
#line 1405 "gram.y"
	{ yyval.expr = NewExprConst(HEX_FLOAT, yystack.l_mark[0].value); }
break;
case 268:
#line 1407 "gram.y"
	{ yyval.expr = NewExprConst(CHAR_CONST, yystack.l_mark[0].value); }
break;
case 269:
#line 1409 "gram.y"
	{ yyval.expr = NewExprConst(STRING_CONST, yystack.l_mark[0].value); }
break;
case 270:
#line 1411 "gram.y"
	{ yyval.expr = NewExprConst(VOIDVAL, yystack.l_mark[0].value); }
break;
case 271:
#line 1413 "gram.y"
	{ yyval.expr = NewExprConst(BOOLVAL, yystack.l_mark[0].value); }
break;
case 272:
#line 1415 "gram.y"
	{ 
			yyval.expr = BuildFullname (0, AtomId ("[]"));
		    }
break;
case 273:
#line 1419 "gram.y"
	{ 
			ParseCanonType (yystack.l_mark[-4].type, False);
			if (yystack.l_mark[-1].expr)
			    yystack.l_mark[-1].expr->base.type = yystack.l_mark[-4].type;
			yyval.expr = NewExprTree (NEW, yystack.l_mark[-1].expr, 0);
			yyval.expr->base.type = yystack.l_mark[-4].type;
		    }
break;
case 274:
#line 1427 "gram.y"
	{ 
			yystack.l_mark[-1].expr->base.type = NewTypeArray (typePoly, yystack.l_mark[-5].expr, True); 
			ParseCanonType (yystack.l_mark[-1].expr->base.type, False);
			yyval.expr = NewExprTree (NEW, yystack.l_mark[-1].expr, 0); 
			yyval.expr->base.type = yystack.l_mark[-1].expr->base.type;
		    }
break;
case 275:
#line 1434 "gram.y"
	{ 
			TypePtr	t = NewTypeArray (typePoly, yystack.l_mark[-5].expr, False);
			ParseCanonType (t, False);
			yyval.expr = NewExprTree (NEW, yystack.l_mark[-1].expr, 0); 
			if (yystack.l_mark[-1].expr)
			    yystack.l_mark[-1].expr->base.type = t;
			yyval.expr->base.type = t;
		    }
break;
case 276:
#line 1443 "gram.y"
	{
			TypePtr t = NewTypeHash (typePoly, yystack.l_mark[-5].type);
			ParseCanonType (t, False);
			yyval.expr = NewExprTree (NEW, yystack.l_mark[-1].expr, 0);
			if (yystack.l_mark[-1].expr)
			    yystack.l_mark[-1].expr->base.type = t;
			yyval.expr->base.type = t;
		    }
break;
case 277:
#line 1452 "gram.y"
	{
			ParseCanonType (yystack.l_mark[-2].type, False);
			yyval.expr = NewExprTree (UNION, NewExprAtom (yystack.l_mark[0].atom, 0, False), 0); 
			yyval.expr->base.type = yystack.l_mark[-2].type;
		    }
break;
case 278:
#line 1458 "gram.y"
	{ 
			ParseCanonType (yystack.l_mark[-4].type, False);
			yyval.expr = NewExprTree (UNION, NewExprAtom (yystack.l_mark[-2].atom, 0, False), yystack.l_mark[0].expr); 
			yyval.expr->base.type = yystack.l_mark[-4].type;
		    }
break;
case 279:
#line 1464 "gram.y"
	{ yyval.expr = BuildCall ("History", "fetch", 1, NewExprConst (TEN_NUM, yystack.l_mark[0].value)); }
break;
case 280:
#line 1466 "gram.y"
	{ yyval.expr = NewExprTree (DOLLAR, 0, 0); }
break;
case 281:
#line 1468 "gram.y"
	{ yyval.expr = yystack.l_mark[-1].expr; }
break;
case 282:
#line 1470 "gram.y"
	{ yyval.expr = yystack.l_mark[-1].expr; }
break;
case 283:
#line 1472 "gram.y"
	{ yyval.expr = NewExprTree (OS, NewExprTree (STAR, yystack.l_mark[-3].expr, (Expr *) 0), yystack.l_mark[-1].expr); }
break;
case 284:
#line 1474 "gram.y"
	{ yyval.expr = NewExprTree(OS, yystack.l_mark[-3].expr, yystack.l_mark[-1].expr); }
break;
case 285:
#line 1476 "gram.y"
	{ yyval.expr = NewExprTree (OP, yystack.l_mark[-3].expr, yystack.l_mark[-1].expr); }
break;
case 286:
#line 1478 "gram.y"
	{ yyval.expr = NewExprTree(DOT, yystack.l_mark[-2].expr, NewExprAtom (yystack.l_mark[0].atom, 0, False)); }
break;
case 287:
#line 1480 "gram.y"
	{ yyval.expr = NewExprTree(ARROW, yystack.l_mark[-2].expr, NewExprAtom (yystack.l_mark[0].atom, 0, False)); }
break;
case 289:
#line 1484 "gram.y"
	{ yyval.value = Zero; }
break;
case 311:
#line 1512 "gram.y"
	{ yyval.expr = 0; }
break;
case 312:
#line 1514 "gram.y"
	{ yyval.expr = 0; }
break;
case 313:
#line 1517 "gram.y"
	{ 
			ExprPtr	elts = yystack.l_mark[-3].expr ? ExprRehang (yystack.l_mark[-3].expr, 0) : 0;
			if (yystack.l_mark[-1].bool)
			{
			    ExprPtr i = elts;
			    while (i->tree.right)
				i = i->tree.right;
			    i->tree.right = NewExprTree (COMMA, 
							 NewExprTree (DOTDOTDOT, 0, 0),
							 0);
			}
			yyval.expr = NewExprTree (ARRAY, elts, 0); 
		    }
break;
case 314:
#line 1531 "gram.y"
	{
			yyval.expr = NewExprTree (COMP, NewExprTree (COMP, yystack.l_mark[-5].expr, yystack.l_mark[-4].expr), yystack.l_mark[-2].expr);
		    }
break;
case 315:
#line 1536 "gram.y"
	{ yyval.expr = yystack.l_mark[0].expr; }
break;
case 317:
#line 1540 "gram.y"
	{ yyval.expr = NewExprTree (COMMA, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
break;
case 319:
#line 1544 "gram.y"
	{ 
			SymbolPtr   s;
			s = ParseNewSymbol (publish_private, class_arg, 
					    typePrim[rep_integer], yystack.l_mark[0].atom);
			yyval.expr = NewExprAtom (yystack.l_mark[0].atom, s, False); 
		    }
break;
case 320:
#line 1552 "gram.y"
	{
			SymbolPtr   s;
			Atom	    a = AtomId("[]");
			s = ParseNewSymbol (publish_private, class_undef,
					    typePoly, a);
			yyval.expr = NewExprAtom (a, s, False);
		    }
break;
case 321:
#line 1561 "gram.y"
	{ yyval.expr = NewExprTree (COMMA, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
break;
case 322:
#line 1563 "gram.y"
	{ yyval.expr = NewExprTree (COMMA, 0, yystack.l_mark[0].expr); }
break;
case 326:
#line 1574 "gram.y"
	{ yyval.expr = 0; }
break;
case 327:
#line 1576 "gram.y"
	{ yyval.expr = 0; }
break;
case 328:
#line 1579 "gram.y"
	{
			ExprPtr elts = yystack.l_mark[-2].expr ? ExprRehang (yystack.l_mark[-2].expr, 0) : 0;
			yyval.expr = NewExprTree (HASH, elts, 0);
		    }
break;
case 329:
#line 1585 "gram.y"
	{ yyval.expr = NewExprTree (COMMA, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
break;
case 330:
#line 1587 "gram.y"
	{ yyval.expr = NewExprTree (COMMA, 0, yystack.l_mark[0].expr); }
break;
case 331:
#line 1590 "gram.y"
	{ yyval.expr = NewExprTree (DARROW, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
break;
case 332:
#line 1592 "gram.y"
	{ yyval.expr = NewExprTree (DARROW, 0, yystack.l_mark[0].expr); }
break;
case 335:
#line 1601 "gram.y"
	{ yyval.expr = NewExprTree (STRUCT, ExprRehang (yystack.l_mark[-2].expr, 0), 0); }
break;
case 336:
#line 1604 "gram.y"
	{ yyval.expr = NewExprTree (COMMA, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
break;
case 337:
#line 1606 "gram.y"
	{ yyval.expr = NewExprTree (COMMA, 0, yystack.l_mark[0].expr); }
break;
case 338:
#line 1609 "gram.y"
	{ yyval.expr = NewExprTree (ASSIGN, NewExprAtom (yystack.l_mark[-2].atom, 0, False), yystack.l_mark[0].expr); }
break;
case 339:
#line 1611 "gram.y"
	{ yyval.expr = NewExprTree (ASSIGN, NewExprAtom (yystack.l_mark[-2].atom, 0, False), yystack.l_mark[0].expr); }
break;
case 340:
#line 1613 "gram.y"
	{ yyval.expr = NewExprTree (ASSIGN, NewExprAtom (yystack.l_mark[-2].atom, 0, False), yystack.l_mark[0].expr); }
break;
case 341:
#line 1615 "gram.y"
	{ yyval.expr = NewExprTree (ASSIGN, NewExprAtom (yystack.l_mark[-2].atom, 0, False), yystack.l_mark[0].expr); }
break;
case 345:
#line 1621 "gram.y"
	{ yyval.expr = NewExprTree (ANONINIT, 0, 0); }
break;
#line 4837 "gram.c"
    }
    yystack.s_mark -= yym;
    yystate = *yystack.s_mark;
    yystack.l_mark -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yystack.s_mark = YYFINAL;
        *++yystack.l_mark = yyval;
        if (yychar < 0)
        {
            if ((yychar = YYLEX) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yystack.s_mark, yystate);
#endif
    if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack))
    {
        goto yyoverflow;
    }
    *++yystack.s_mark = (short) yystate;
    *++yystack.l_mark = yyval;
    goto yyloop;

yyoverflow:
    yyerror("yacc stack overflow");

yyabort:
    yyfreestack(&yystack);
    return (1);

yyaccept:
    yyfreestack(&yystack);
    return (0);
}
